<?php
//Fast Site Engine. Copyright © AC (acwed@ya.ru), 2004-2023. All rights reserved. 2-clause BSD license.
define('T',$_SERVER['REQUEST_TIME']);
header('Content-Type: text/html; charset=utf-8');
header('Expires: '.date('r',T));
header('Cache-Control: no-store, no-cache, must-revalidate');
header('Pragma: no-cache');
header('Last-Modified: '.gmdate('D, d M Y H:i:s',T).' GMT');
mb_internal_encoding('UTF-8');
function sip($s,$f){
  return false!==mb_stripos($s,$f)?1:0;
}
$s=$_SERVER['HTTP_USER_AGENT'];
if(sip($s,'wget')||sip($s,'bot')||sip($s,'spider')||sip($s,'yandex')||sip($s,'rambler')||sip($s,'aport')||sip($s,'crawler')||sip($s,'twiceler')||sip($s,'slurp')||sip($s,'webalta')||sip($s,'mail')||sip($s,'parser')||sip($s,'archiv')){header('HTTP/1.1 403 Forbidden');exit(' ');}
$success_page='up/';
define('N', "\n");
define('RN', "\r\n");
function testfile($fe,$txt){
  if(is_file($fe)) return;
  $f=fopen($fe,'w');
  fputs($f,$txt);
  fclose($f);
}
$f='../deny/cp/'; if(!is_dir($f))mkdir($f,0755,1); 
testfile('../deny/.htaccess','Deny from ALL');
testfile($f.'conf.php','<?php'.N.'$cpconf=['.N.'\'onlyip\'=>\'\','.N.'\'banned\'=>\'\''.N.'];');
//------------------------------------------------------------------------------
$s=$_SERVER['HTTP_CLIENT_IP']??$_SERVER['HTTP_X_FORWARDED_FOR']??$_SERVER['REMOTE_ADDR'];
if(filter_var($s,FILTER_VALIDATE_IP,FILTER_FLAG_IPV6))$s=inet_ntop(inet_pton($s));
define('IP',$s);
require '../deny/cp/conf.php';
$a=str_replace(' ','',$cpconf['onlyip']);
$b=str_replace(' ','',$cpconf['banned']);
if(''!=$a || ''!=$b){
  require '../deny/ip.php';
  $i=new ip(IP);
  if(''!=$a && !$i->in($a)){header('HTTP/1.1 403 Forbidden');exit('Access limited by IP.');}
  if(''!=$b && $i->in($b)){header('HTTP/1.1 403 Forbidden');exit('Access denied from this IP.');}
}
//------------------------------------------------------------------------------
testfile('../inc/tpl/.htaccess','Options -Indexes'.N.'#php_flag engine 0'.N.'RemoveHandler .phtml .php .php3 .php4 .php5 .php6 .phps .cgi .exe .pl .asp .aspx .shtml .shtm .fcgi .fpl .jsp .htm .html .wml'.N.'AddType application/x-httpd-php-source .phtml .php .php3 .php4 .php5 .php6 .phps .cgi .exe .pl .asp .aspx .shtml .shtm .fcgi .fpl .jsp .htm .html .wml');
$f='../inc/tpl/inc/'; if(!is_dir($f))mkdir($f,0755,1); testfile($f.'.htaccess','Deny from ALL');
$f='../inc/tpl/inc/_keys.php'; testfile($f, '<?php'.N.'$sesname=\''.rand(1000000000,2147483647).'\';'.N.'$usrs=['.N.'0=>[\'id\'=>\'afde3e7059cd0a0fe09eec4b0008cdafde3e7059cd0a0fe09eec4b0008cdabcdeflmnvwuprs\',\'name\'=>\'Main manager\']'.N.',1=>[\'id\'=>\'9ad0a86347fe9f6b8d16123d0982879ad0a86347fe9f6b8d16123d098287ubvcmf\',\'name\'=>\'Manager\']'.N.'];');
include $f;
//------------------------------------------------------------------------------
session_start();
if(isset($_GET['exit'])){ unset($_SESSION['AC'.$sesname]); header('Location: ./'); }
function s($name, $value=''){
  global $sesname;
  if('' == $value) return isset($_SESSION['AC'.$sesname][$name])? $_SESSION['AC'.$sesname][$name]: false;
  $_SESSION['AC'.$sesname][$name]=$value;
}
$f='../inc/tpl/inc/_sys.php'; testfile($f, '<?php'.N.'$sys=['.N.'\'https\'=>1,'.N.'\'www\'=>1,'.N.'\'slash\'=>1,'.N.'\'fse\'=>\'\','.N.'\'name\'=>\'\','.N.'\'startlang\'=>\'ru\','.N.'\'lang\'=>[\'ru\'=>1],'.N.'\'slangs\'=>[\'ru\'=>1,\'en\'=>1],'.N.'\'mirror\'=>1,'.N.'\'js\'=>1,'.N.'\'ico\'=>1,'.N.'\'gif\'=>0,'.N.'\'meta\'=>\'\','.N.'\'counters\'=>\'`Counters`\'];');
include $f;
$f='../inc/tpl/inc/vars_ru.php'; testfile($f, '<?php'.N.'$v=['.N.'\'startpage\'=>\'main\','.N.'\'style\'=>\'def\','.N.'\'framex\'=>724,'.N.'\'company\'=>\'\','.N.'\'title\'=>\'\','.N.'\'txt\'=>\'&copy; Все права защищены\','.N.'\'year\'=>\''.date('Y').'\','.N.'\'phone\'=>\'\','.N.'\'fax\'=>\'\','.N.'\'email\'=>\'\','.N.'\'fmail\'=>\'\','.N.'\'from\'=>\'\','.N.'\'ogtype\'=>\'\','.N.'\'ogurl\'=>\'\','.N.'\'ogname\'=>\'\','.N.'\'ogtitle\'=>\'\','.N.'\'ogdesc\'=>\'\','.N.'\'ogimage\'=>\'\','.N.'\'ogwidth\'=>\'\','.N.'\'ogheight\'=>\'\','.N.'\'ogalt\'=>\'\'];');
include $f;
$f='../robots.txt';
if(!is_file($f)){
  $s='';
  if(''!=$sys['name'])$s=$sys['name'];
  else $s=$_SERVER['SERVER_NAME'];
  $s=str_replace('www.','',$s);
  if(''!=$s && 'test1.ru'!=$s){
    $a=explode('/',$_SERVER['REQUEST_URI']);
    $t=(''!=$a[sizeof($a)-1])?$a[sizeof($a)-1]:$a[sizeof($a)-2];
    testfile($f,'User-Agent: *'.N.'Disallow: /'.$t.'/'.N.'Host: '.$s);
  }
}
//------------------------------------------------------------------------------
if(isset($_GET['lang'])){
  $l=HGET('lang');
  if(isset($sys['lang'][$l])){
    setcookie('alang',$l,$_SERVER['REQUEST_TIME']+2592000,'/','.'.$_SERVER['SERVER_NAME'],0);//30days
    s('lang',$l);
    define('L',$l);
  }
} elseif(isset($_COOKIE['alang'])){
  $l=$_COOKIE['alang'];
  if(isset($sys['lang'][$l])){
    s('lang',$l);
    define('L',$l);
  }
}
if(!defined('L')){
  foreach($sys['lang'] as $k=>$x){$l=$k;break;}
  s('lang',$l);
  define('L',$l);
 }
$lanagSwich='';
if(1<sizeof($sys['lang'])){
  $i=0;
  foreach($sys['lang'] as $k=>$x){
    $s=(L==$k)?$k:'<a href="?lang='.$k.'">'.$k.'</a>';
    $lanagSwich.=(0!=$i)?' / '.$s:$s;
    ++$i;
  }
}
include '_inc/lng_'.L.'.php';
$l=$lng['login'];
//------------------------------------------------------------------------------
function Logme($file,$name){
  $fn='../inc/tpl/inc/'.$file.'.log';
  if(is_file($fn)){
    $fa=file($fn);
    if(1000<count($fa)){
      for($i=0; $i<500; $i++) unset($fa[$i]);
      $f=fopen($fn, 'w');
      fwrite($f, implode('',$fa));
    } else $f=fopen($fn, 'a');
  } else $f=fopen($fn, 'a');
  fwrite($f,'['.date('Y.m.d H:i').'] ['.IP.'] ['.$name.'] ['.getenv('HTTP_USER_AGENT').']'.N);
  fclose($f);
}
$n=0;
$arr=[];
$finded=false;
$fe='../inc/tpl/inc/trylogin.log'; testfile($fe, '');
testfile('../inc/tpl/inc/actions.log', '');
$fa=file($fe);
$c=count($fa);
$time=$_SERVER['REQUEST_TIME'];
for($i=0;$i<$c;$i++){//time|ip|times|
  $ar=explode('|', $fa[$i]);
  if(count($ar)>1){
    if($ar[0]+600<$time) continue;
    $ar[2]++;
    if($ar[1] == IP){
      if(10<$ar[2]){ $t=$ar[0]+600-$time; exit('<!DOCTYPE html><html><head><meta charset="utf-8"><title></title></head><body>'.$l['banned'].date('i:s',$t).'</body></html>'); }
      $finded=true;
    }
    $arr[$n]=$_SERVER['REQUEST_TIME'].'|'.IP.'|'.$ar[2].'|'.N;
    ++$n;
  }
} if(!$finded) $arr[$n]=$_SERVER['REQUEST_TIME'].'|'.IP.'|1|'.N;
//------------------------------------------------------------------------------
if(isset($_POST['user'])){
  function HHPOST($v){
    return isset($_POST[$v])?$_POST[$v]:'';
  }
  if(!s('admname')){
    if(!isset($_POST['user']) || !isset($_POST['pass']))header('Location: ?error');
    $xuser=substr(md5(md5(HHPOST('user'))),2,30).substr(md5(md5(HHPOST('pass'))),2,30);
    $uexists=false;
    $c=count($usrs);
    for($i=0; $i<$c; $i++){
      $r=$usrs[$i];
      if($xuser == substr($r['id'],0,60)){
        $uexists=true;
        //$_SESSION['AC'.$sesname]='';
        //if(!isset(L)) L=$sys['lang'][0];
        s('admname',$r['name']);
        s('admrights',mb_substr($r['id'],60,mb_strlen($r['id'])));
        break;
      }
    }
    if(!$uexists){
      unset($_SESSION['AC'.$sesname]);
      $f=fopen($fe, 'w');
      fwrite($f, implode('',$arr));
      fclose($f);
      Logme('loginerror',HHPOST('user'));
      header('Location: ?error');
    } else {
      $f='../inc/img/'; if(!is_dir($f))mkdir($f,0755,1);
      $f='../inc/doc/'; if(!is_dir($f))mkdir($f,0755,1);
      testfile('../inc/tpl/inc/menu_ru.php','<?php'.N.'$menu=['.N.'];');
      Logme('login',s('admname'));
      header('Location: '.$success_page);
    }
  }
} else {
  echo '<!DOCTYPE html><html><head><meta charset="utf-8">
    <title>'.$l['Authorization'].'</title>
    <style>
      html{height:100%}
      body{height:100%;margin:0px;padding:0px;font:bold 13px/16px Verdana;color:#3c3e3c;background-color:#e7e2d6}
      td{font:bold 13px/16px Verdana}
      textarea,input{resize:none;outline:none}
      button,input[type=\'button\'],input[type=\'submit\']{padding:7px 18px 6px;font:14px/14px Verdana;letter-spacing:.04em;color:#000;background-color:#fff;border-radius:6px;border:1px solid #ccc;cursor:pointer;transition:.3s ease}
      button:hover,input[type=\'button\']:hover,input[type=\'submit\']:hover{background-color:#efefef}
      a:link,a:visited{font:13px/16px Verdana;color:#193248}
      a:active,a:hover{font:13px/16px Verdana;color:#c11438}
    </style>
    <script>
    <!--
    function gid(id){
      return document.getElementById(id)
    }
    function substr(str,start,len) {
      str += \'\';
      var end=str.length;
      if(start<0) start += end;
      end=typeof len === \'undefined\' ? end : (len<0 ? len + end : len + start);
      return start >= str.length || start<0 || start > end ? !1 : str.slice(start, end);
    }
    function is_numeric(mixed_var) {
      return (typeof(mixed_var) === \'number\' || typeof(mixed_var) === \'string\') && mixed_var !== \'\' && !isNaN(mixed_var);
    }
    function isru(v){
      var size=v.length,s;
      for(var i=size; i>0; i--){
        s=substr(v, i-1, 1);
        if(is_numeric(s)) continue;
        if(/[а-яА-Я]/.test(s) == true) return true;
        else return false;
      }
    }
    function isen(v){
      var size=v.length,s;
      for(var i=size; i>0; i--){
        s=substr(v, i-1, 1);
        if(is_numeric(s)) continue;
        if(/[a-zA-Z]/.test(s) == true) return true;
        else return false;
      }
    }
    function cl(o){
      var val=o.value;
      if(val ==\'\') return;
      if(isru(val)) gid(\'ul\').innerHTML=\'ru\';
      else if(isen(val)) gid(\'ul\').innerHTML=\'en\';
    }
    -->
    </script>
    </head><body>
    <form action="./" method="post" style="width:100%;height:100%">
    <table style="width:100%;height:100%;borer:none"><tr><td style="vertical-align:middle;text-align:center">';
  if(isset($_GET['error'])) echo '<div style="margin:0 auto;"><b>'.$l['err'].'</b></div><br>';
  echo '<table style="width:320px;margin:0 auto;"><tr><td>'.$lanagSwich.'</td></tr></table><table style="width:320px;border:1px solid #838280;border-radius:5px;margin:0 auto;"><tr><td colspan="3" style="text-align:right"><span id="ul"></span><br></td><td style="width:25px"></td></tr>';
  if(!s('admname')){
    echo '<tr><td style="width:25px"></td><td style="width:70px">'.$l['User'].' </td><td><input type="password" name="user" value=\'\' onKeyUp="cl(this)"></td><td style="width:25px"></td></tr>
      <tr><td style="width:25px"></td><td style="width:70px">'.$l['Pass'].' </td><td><input type="password" name="pass" value=\'\' onKeyUp="cl(this)"></td><td style="width:25px"></td></tr>
      <tr><td colspan="4"><br></td></tr>
      <tr><td style="width:25px"></td><td colspan="2"><input type="submit" style="width:284px" value="'.$l['login'].'"></td><td style="width:25px"></td></tr>';
    unset($_SESSION['AC'.$sesname]);
  } else echo '<tr><td colspan="4"><script>'.N.'<!--'.N.'window.location="'.$success_page.'";'.N.'-->'.N.'</script></td></tr>';
} echo '<tr><td colspan="4"><br></td></tr></table></td></tr></table></form></body></html>';
