<?php
//Fast Site Engine. Copyright © AC (acwed@ya.ru), 2004-2023. All rights reserved. 2-clause BSD license.
include '../validate.php';
if(!isset($_POST['z_lnk']))logout();
$_SESSION['menuseen']=HPOST('menuseen');
function translate($s){
$s=preg_replace('/\s+/',' ',trim($s));
$a=['а'=>'a','б'=>'b','в'=>'v','г'=>'g','д'=>'d','е'=>'e','ё'=>'yo','ж'=>'zh','з'=>'z','и'=>'i','й'=>'i','к'=>'k','л'=>'l','м'=>'m','н'=>'n','о'=>'o','п'=>'p','р'=>'r','с'=>'s','т'=>'t','у'=>'u','ф'=>'f','х'=>'kh','ц'=>'ts','ч'=>'ch','ш'=>'sh','щ'=>'shch','ъ'=>'ie','ы'=>'y','ь'=>'','э'=>'e','ю'=>'iu','я'=>'ia','А'=>'A','Б'=>'B','В'=>'V','Г'=>'G','Д'=>'D','Е'=>'E','Ё'=>'YO','Ж'=>'ZH','З'=>'Z','И'=>'I','Й'=>'I','К'=>'K','Л'=>'L','М'=>'M','Н'=>'N','О'=>'O','П'=>'P','Р'=>'R','С'=>'S','Т'=>'T','У'=>'U','Ф'=>'F','Х'=>'KH','Ц'=>'TS','Ч'=>'CH','Ш'=>'SH','Щ'=>'SHCH','Ъ'=>'IE','Ы'=>'Y','Ь'=>'','Э'=>'E','Ю'=>'IU','Я'=>'IA',' '=>'-','_'=>'-'];
$s=strtr($s,$a);
return preg_replace('/[^0-9a-z-.]/i','',$s);
}
function makedir($n){
  if(!is_dir($n)) @mkdir($n,0777);
}
function testfile($v,$txt){
  if(is_file($v)) return;
  $f=fopen($v,'w');
  fputs($f,$txt);
  fclose($f);
}
$a=[0=>'\\',1=>'\'',2=>'"'];
$b=[0=>'',1=>'&#39;',2=>'&#34;'];
function v($c){
  global $a,$b;
  $c=trim($c,"\x00..\x1F");
  $c=preg_replace("/(\n|\r)/",'',$c);
  $c=str_replace(');',')',$c);
  return str_replace($a,$b,stripslashes($c));
}
function ret($id){
  global $lnk,$sys;
  if(!isset($_POST[$id]))$_POST[$id]='';
  $s=HPOST($id);
  if('z_name'==$id){
    if($s==''){
      foreach($sys['lang'] as $k=>$x){$l=$k;break;}
      $s=HPOST($l.'z_text');
    }
    $s=strtolower(translate($s));
    if(false!=$lnk) $s=substr($s,0,40);
  } return trim(v($s));
}
$plang=HPOST('lang');
$lnk=ret('z_lnk');
$mtyp=ret('z_mtyp');
$active=ret('z_active');
$name=preg_replace('/\s/','-',trim(translate(ret('z_name'))));
if(''==$name) $name=substr(translate(ret($plang.'z_text')),0,40);
$name=strtolower($name);
$par1=ret('z_par1');
$par2=ret('z_par2');
$par3=ret('z_par3');
$p=HPOST('z_typ');
$target=('false'!=$lnk)? '_blank': '_self';
$descr=$keyw=$h1=$hint='';
if(1==$p){
  $par1='';
  $par2='';
  $par3='';
}elseif(2==$p){
  $par2='';
  $par3='';
}elseif(3==$p) $par3='';
if($sys['mirror']){//-----------------------------------------------
  foreach($sys['lang'] as $k=>$x){
    $val=$k;
    include 'lng_'.$val.'.php';
    $lt=$lng['menu'];
    $text=str_replace('`~','&amp;',ret($val.'z_text'));
    $title=str_replace('+#34;','&#34;',ret($val.'z_title'));
    $fp='../../inc/tpl/'.$p.'/';
    makedir($fp);
    testfile($fp.'.htaccess','Deny from ALL');
    $fp .= $val.'/';
    makedir($fp);
    while(is_file($fp.$name.'.tpl')) $name .= 'i';
    $fm='../../inc/tpl/inc/menu_'.$val.'.php';
    include $fm;
    $lc=sizeof($menu);
    $c=$lc.'=>[\'typ\'=>\''.$mtyp.'\',\'active\'=>\''.$active.'\',\'lnk\'=>'.$lnk.',\'name\'=>\''.$name.'\',\'text\'=>\''.$text.'\',\'hint\'=>\''.$hint.'\',\'par1\'=>\''.$par1.'\',\'par2\'=>\''.$par2.'\',\'par3\'=>\''.$par3.'\',\'target\'=>\''.$target.'\',\'title\'=>\''.$title.'\']';
    $fp='../../inc/tpl/'.$p.'/'.$val.'/';
    $f=fopen($fp.$name.'.tpl','w');
    fwrite($f,$c.N.'<!-- START:descr -->'.$descr.N.'<!-- START:keyw -->'.$keyw.N.'<!-- START:body:title -->'.N.'<!-- START:h1 -->'.$h1.N.'<!-- START:h1:title -->'.N.'<!-- START:txt -->'.$text.' - '.ll('SectionEmpty').N.'<!-- END:txt -->');      
    fclose($f);
    if($lc==0){
      $fp=fopen($fm,'w');
      fwrite($fp,'<?php'.N.'$menu=['.N);
    } else {     
      $f=implode('',file($fm));
      $f=explode('];',$f);      
      $fp=fopen($fm,'w');  
      fwrite($fp,$f[0]);  
      $c=','.$c;  
    }
    fwrite($fp,$c.N.'];');
    fclose($fp);
  }
} else {//----------------------------------------------------------------------
  $val=$plang;
  include 'lng_'.$val.'.php';
  $lt=$lng['menu'];
  $text=str_replace('`~','&amp;',ret($val.'z_text'));
  $title=str_replace('+#34;','&#34;',ret($val.'z_title'));
  $fp='../../inc/tpl/'.$p.'/';
  makedir($fp);
  testfile($fp.'.htaccess','Deny from ALL');
  $fp .= $val.'/';
  makedir($fp);
  while(is_file($fp.$name.'.tpl')) $name .= 'i';
  $fm='../../inc/tpl/inc/menu_'.$val.'.php';
  include $fm;
  $lc=sizeof($menu);
  $c=$lc.'=>[\'typ\'=>\''.$mtyp.'\',\'active\'=>\''.$active.'\',\'lnk\'=>'.$lnk.',\'name\'=>\''.$name.'\',\'text\'=>\''.$text.'\',\'hint\'=>\''.$hint.'\',\'par1\'=>\''.$par1.'\',\'par2\'=>\''.$par2.'\',\'par3\'=>\''.$par3.'\',\'target\'=>\''.$target.'\',\'title\'=>\''.$title.'\']';
  $fp='../../inc/tpl/'.$p.'/'.$val.'/';
  $f=fopen($fp.$name.'.tpl','w');
  fwrite($f,$c.N.'<!-- START:descr -->'.$descr.N.'<!-- START:keyw -->'.$keyw.N.'<!-- START:body:title -->'.N.'<!-- START:h1 -->'.$h1.N.'<!-- START:h1:title -->'.N.'<!-- START:txt -->'.$text.' - '.ll('SectionEmpty').N.'<!-- END:txt -->');
  fclose($f);
  if($lc==0){
    $fp=fopen($fm,'w');
    fwrite($fp,'<?php'.N.'$menu=['.N);
  } else {     
    $f=implode('',file($fm));
    $f=explode('];',$f);      
    $fp=fopen($fm,'w');  
    fwrite($fp,$f[0]);  
    $c=','.$c;  
  }
  fwrite($fp,$c.N.'];');
  fclose($fp);
}//-----------------------------------------------------------------------------
$s='';
if(''!=$par1) $s=$par1.'/';
if(''!=$par2) $s=$s.$par2.'/';
if(''!=$par3) $s=$s.$par3.'/';
$s=$s.$name.'/';
Logme('AddMenu <a href="../context/'.$s.'" target="_blank" style="color:#0000ff">'.$s.'</a> ');
Header('Location: ./');
