<?php
//Fast Site Engine. Copyright © AC (acwed@ya.ru), 2004-2023. All rights reserved. 2-clause BSD license.
include '../validate.php';
$plang=HPOST('lang');
if(isset($_POST['save']) && isset($_SESSION['_menu'])){
  $size = sizeof($_SESSION['_menu']);
  $s='<?php'.N.'$menu=['.N;
  for($i=0; $i<$size; $i++){
    $val = $_SESSION['_menu'][$i]['body'];
    $e=(0==$i)?'':',';
    $s=$s.$e.$i.'=>['.$val;
  }
  $f = fopen('../../inc/tpl/inc/menu_'.$plang.'.php', 'w');
  fwrite($f, $s.'];');
 	fclose($f);
  Logme('RestoreMenu');
  unset($_SESSION['_menu']);
  exit(N.'<script language="JavaScript" type="text/javascript">'.N.'window.opener.location.reload();'.N.'window.close();'.N.'</script>'.N);
}
include 'lng_'.$plang.'.php';
$menu = [];
$lt = $lng['menu'];
function ep($s,$n){
  $s = explode('\''.$n.'\'=>\'', $s);
  $s = explode('\'', $s[1], 2);
  return $s[0];
}
function readfolder($d){
  global $menu;
  if(!is_dir($d)) return false;
  if(!$folder=opendir($d)) return false;
  while(false !== ($file=readdir($folder))){
    if($file=='.' || $file=='..') continue;
    if(strtolower(substr($file, -3, 3)) == 'tpl'){
      $f = implode('',file($d.$file));
      $f = explode('<!-- START:descr -->', $f);  
      $f = explode('=>[', $f[0]);
      $f[0] = str_replace(',','',$f[0]);
      if(is_numeric($f[0])){
        $menu[] = ['typ'=>ep($f[1],'typ'),'par1'=>ep($f[1],'par1'),'par2'=>ep($f[1],'par2'),'par3'=>ep($f[1],'par3'),
          'name'=>ep($f[1],'name'),'text'=>ep($f[1],'text'),'pos'=>$f[0],'body'=>$f[1]];
      }
    }
  } closedir($folder);
}
readfolder('../../inc/tpl/1/'.$plang.'/');
readfolder('../../inc/tpl/2/'.$plang.'/');
readfolder('../../inc/tpl/3/'.$plang.'/');
readfolder('../../inc/tpl/4/'.$plang.'/');
echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
  <html><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8"><title>protected page</title>
  <link rel="stylesheet" href="../_inc/_.css" type="text/css">
  <style type="text/css">
    *{font:normal 10px Verdana}
    td{color:#000}
    .f6{background-color:#eae9e9}
    .e5{background-color:#dedddd}
    .d3{background-color:#d3d1d1}
    .c0{background-color:#c0c0c0}
  </style></head><body><table style="margin:0 auto"><tr><td>'.ll('findedmenus').'<br>';
$tmenu = [];
$lcount=sizeof($menu);
$n=0;
$i=0;
function finded($v){
  global $menu, $lcount;
  for($x=0; $x<$lcount; $x++){
    $r = $menu[$x];
    if($r['pos'] == $v) return true;
  } return false;
}
while($n<$lcount){
  if(!finded($i)) ++$i;
  else{
    for($x=0; $x<$lcount; $x++){
      $r = $menu[$x];
      if($r['pos'] == $i){
        $tmenu[]=$r;
        ++$n;
      }
    } ++$i;
  }
}
$_SESSION['_menu']=$menu=$tmenu;
function ishave($typ, $par1, $par2, $par3){
  global $menu, $lcount;
  for($x=0; $x<$lcount; $x++){
    $r = $menu[$x];
    if($r['typ'] == $typ && $r['par1'] == $par1 && $r['par2'] == $par2 && $r['par3'] == $par3) return true;
  } return false;
}
function menu($typ,$par1='',$par2='',$par3=''){
  global $g, $lng, $sp, $thispach, $lt, $len, $v, $menu, $lcount;
  static $c1, $c2, $c3, $mtyp;
  if(!ishave($typ, $par1, $par2, $par3)) return;
  if(!isset($mtyp)) $mtyp = '';
  if(!isset($c1)) $c1 = 0;
  if(!isset($c2)) $c2 = 0;
  if(!isset($c3)) $c3 = 0;
  if($mtyp != $typ){
    $c1 = 0;
    $mtyp = $typ;
    echo $lng['menu'][$typ];
  }
  $p = 1;
  $i = $c1;
  if(''!=$par1){
        if(''==$par2 && ''==$par3) { $p = 2; $i = $c2; }
    elseif(''!=$par2 && ''==$par3){ $p = 3; $i = $c3; }
    elseif(''!=$par2 && ''!=$par3){ $p = 4; $i = 0; }
  }
  for($x=0; $x<$lcount; $x++){
    $r = $menu[$x];
    $pl = '';
    if($r['typ']==$typ && $r['par1']==$par1 && $r['par2']==$par2 && $r['par3']==$par3){
      if($p == 4){
        $nbsp = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
        $lines = '----';
        $color = 'f6';
      } elseif($p == 3){
        $nbsp = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
        $lines = '---';
        $color = 'e5';
      } elseif($p == 2){
        $nbsp = '&nbsp;&nbsp;&nbsp;&nbsp;';
        $lines = '--';
        $color = 'd3';
      } elseif($p == 1){
        $nbsp = '';
        $lines = '-';
        $color = 'c0';
      }
      echo '<table width="600"><tr><td class="'.$color.'" align="left">&nbsp;'.$nbsp.$lines.'&nbsp;'.$r['text'].'</td></tr></table>';
      if($p == 3){
        $c3 = $x+1;
        menu($typ, $r['par1'], $r['par2'], $r['name']);
      } elseif($p == 2){
        $c3 = 0;
        $c2 = $x+1;
        menu($typ, $r['par1'], $r['name']);
      } elseif($p == 1){
        $c2 = 0;
        $c1 = $x+1;
        menu($typ, $r['name']);
      }
    }
  }
}
menu('top');
menu('left');
menu('right');
menu('bottom');
menu('hidden');
echo '<br><form action="?save" method="post"><input type="hidden" name="save" value=""><input type="submit" name="submit" value="'.ll('save').'"></form><br><br></td></tr></table></body></html>';