<?php
//Fast Site Engine. Copyright © AC (acwed@ya.ru), 2004-2023. All rights reserved. 2-clause BSD license.
define('T',$_SERVER['REQUEST_TIME']);
header('Content-Type: text/html; charset=utf-8');
header('Expires: '.date('r',T));
header('Cache-Control: no-store, no-cache, must-revalidate');
header('Pragma: no-cache');
header('Last-Modified: '.gmdate('D, d M Y H:i:s',T).' GMT');
mb_internal_encoding('UTF-8');
function sip($s,$f){
  return false!==mb_stripos($s,$f)?1:0;
}
$s=$_SERVER['HTTP_USER_AGENT'];
if(sip($s,'wget')||sip($s,'bot')||sip($s,'spider')||sip($s,'yandex')||sip($s,'rambler')||sip($s,'aport')||sip($s,'crawler')||sip($s,'twiceler')||sip($s,'slurp')||sip($s,'webalta')||sip($s,'mail')||sip($s,'parser')||sip($s,'archiv')){header('HTTP/1.1 403 Forbidden');exit(' ');}
$s=$_SERVER['HTTP_CLIENT_IP']??$_SERVER['HTTP_X_FORWARDED_FOR']??$_SERVER['REMOTE_ADDR'];
if(filter_var($s,FILTER_VALIDATE_IP,FILTER_FLAG_IPV6))$s=inet_ntop(inet_pton($s));
define('IP',$s);
require '../../deny/cp/conf.php';
$a=str_replace(' ','',$cpconf['onlyip']);
$b=str_replace(' ','',$cpconf['banned']);
if(''!=$a || ''!=$b){
  require '../../deny/ip.php';
  $i=new ip(IP);
  if(''!=$a && !$i->in($a)){header('HTTP/1.1 403 Forbidden');exit('Access limited by IP.');}
  if(''!=$b && $i->in($b)){header('HTTP/1.1 403 Forbidden');exit('Access denied from this IP.');}
}
require '../../inc/tpl/inc/_sys.php';
require '../../inc/tpl/inc/_keys.php';
define('N',"\n");
define('RN',"\r\n");
session_start();
function s($name,$value=''){
  global $sesname;
  if(''==$value)return isset($_SESSION['AC'.$sesname][$name])?$_SESSION['AC'.$sesname][$name]:false;
  $_SESSION['AC'.$sesname][$name]=$value;
}
function removedir($d){
  if(is_dir($d)){
    $dir=opendir($d);
    while(false!==($file=readdir($dir))){
      if(is_file($d.'/'.$file)) unlink ($d.'/'.$file);
      elseif(is_dir($d.'/'.$file) && $file!='.' && $file!='..')removedir($d.'/'.$file);
    } closedir($dir);
    rmdir($d);
  }
}
function rmempty($d){
  if(is_dir($d) && $o=opendir($d)){
    $dirempty=1;
    while(false!==($r=readdir($o))){
      if('.'==$r || '..'==$r) continue;
      if(is_dir($d.$r) || is_file($d.$r)){$dirempty=0;break;}
    } closedir($o);
    if($dirempty)rmdir($d);
  }
}
function logout(){
  global $sesname;
  unset($_SESSION['AC'.$sesname]);//session_destroy();
  removedir('../../inc/tpl/_thumb/');
  header('Location: ../');
}
if(!s('admname') || ''==s('admname') || isset($_GET['exit']))logout();
function Logme($mes){
  $fn='../../inc/tpl/inc/actions.log';
  if(is_file($fn)){
    $fa=file($fn);
    if(1000<count($fa)){
      for($i=0; $i<500; $i++) unset($fa[$i]);
      $f=fopen($fn,'w');
      fwrite($f,implode('',$fa));
    } else $f=fopen($fn,'a');
  } else $f=fopen($fn,'a');
  fwrite($f,'['.date('Y.m.d H:i').'] ['.s('admname').'] ['.$mes.']'.N);
  fclose($f);
}
function HGET($v){
  return isset($_GET[$v])?$_GET[$v]:'';
}
function HPOST($v){
  return isset($_POST[$v])?$_POST[$v]:'';
}
if(isset($_GET['lang'])){
  $l=HGET('lang');
  if(isset($sys['lang'][$l])){
    setcookie('alang',$l,$_SERVER['REQUEST_TIME']+2592000,'/','.'.$_SERVER['SERVER_NAME'],0);//30days
    s('lang',$l);
    define('L',$l);
  }
}
if(!defined('L')){
  $l=s('lang');
  if(isset($sys['lang'][$l]))define('L',$l);
  else{
    foreach($sys['lang'] as $k=>$v){$l=$k;break;}
    s('lang',$l);
    define('L',$l);
  }
}
$lanagSwich='';
if(1<sizeof($sys['lang'])){
  $w=isset($_GET['q'])?'?q='.HGET('q').'&':'?';
  $i=0;
  foreach($sys['lang'] as $k=>$x){
    $s=(L==$k)?$k:'<a href="'.$w.'lang='.$k.'">'.$k.'</a>';
    $lanagSwich.=(0!=$i)?' / '.$s:$s;
    ++$i;
  }
}
function ll($v){
  global $lt;
  return $lt[$v];
}
$am=[0=>'`~',1=>'`^',2=>'&#34;'];
$bm=[0=>'&',1=>'+',2=>'"'];
function unecran($v){//it's post
  global $am,$bm;
  return str_replace($am,$bm,stripslashes($v));
}
if(is_file('map.php')){
  include 'map.php'; 
  $rights=s('admrights');
  if(!strstr($rights,$map[0]['rights']))exit;
  unset($map);
}