<?php
//Fast Site Engine. Copyright © AC (acwed@ya.ru), 2004-2023. All rights reserved. 2-clause BSD license.
if(!function_exists('zonecity')){
function zoneregion($z=128,$c='',$j=L,$o=0){
  global $l;
  $j=loadl('zones',$j);
  if(!is_numeric($z)){
    $t=mb_strtoupper($z);
    $a=['AFRICA'=>1,'AMERICA'=>2,'ANTARCTICA'=>4,'ARCTIC'=>8,'ASIA'=>16,'ATLANTIC'=>32,'AUSTRALIA'=>64,'EUROPE'=>128,
        'INDIAN'=>256,'PACIFIC'=>512,'UTC'=>1024,'ALL'=>2047,'ALL_WITH_BC'=>4095,'PER_COUNTRY'=>4096];
    if(isset($a[$t]))$z=$a[$t];
    else{
      foreach($l['zoneregion'][$j] as $k=>$v)if(false!==mb_stripos($v,$z)){$z=$k;break;}
      if(!is_int($z))$z=2047;
    }
  }
  if(0==$o){$s='<span role="option" data-v="';$e='</span>';}
  elseif(1==$o){$s='<li role="option" data-v="';$e='</li>';}
  else{$s='<option value="';$e='</option>';$o=2;}
  if($c)$c=' '.trim($c);
  $t=$n=$m='';
  foreach($l['zoneregion'][$j] as $k=>$v){
    $t.=$s.$k.'"';
    if($k==$z){$n=$k;$m=$v;$t.=2==$o?' selected':' class="selected"';}
    else $t.=$c;//onclick
    $t.='>'.$v.$e;
  } return ['value'=>$n,'text'=>$m,'options'=>$t];
}
function zonecity($r=128,$z='Europe/Moscow',$c='',$j=L,$o=0,$w=1,$d='<small>+%02d:%02d</small>',$d0=0){
  global $l;
  $j=loadl('zones',$j);
  if(0==$o){$s='<span role="option" data-v="';$e='</span>';}
  elseif(1==$o){$s='<li role="option" data-v="';$e='</li>';}
  else{$s='<option value="';$e='</option>';$o=2;}
  if($c)$c=' '.trim($c);
  $t=$n=$m='';
  $w=$w && 513>$r;
  if($w){
    $x=[];$i=0;
    foreach($l['zoneregion'][$j] as $k=>$v){
      if(513<$k)break;
      $x[$i]=$v.'/';
      ++$i;
    }
  }
  if($d)$u=new DateTimeZone('UTC');
  $a=timezone_identifiers_list($r);
  $f=1;foreach($a as $k=>$v)if($v==$z){$f=0;break;}
  if($f)foreach($a as $k=>$v){$z=$v;break;}
  foreach($a as $k=>$v){
    $f=$l['zones'][$j][$v]??$v;
    if($w)$f=str_replace($x,'',$f);
    $t.=$s.$v.'"';
    if($v==$z){$n=$v;$m=$f;$t.=2==$o?' selected':' class="selected"';}
    else $t.=$c;//onclick
    if($d){
      $b=new DateTimeZone($v);
      $b=$b->getOffset(new DateTime('now',$u));
      $h=floor(abs($b)/3600);$h=$h%3600;$i=floor($h/60);
      if(0==$h && 0==$i)$q=$d0?' '.sprintf($d0,$h,$i):'';
      else{
        if(0>$b)$p='-';
        else $p='+';
        $q=' '.sprintf($d,$h,$i);
        if('+'!=$p)$q=str_replace('+',$p,$q);
      }
    }else $q='';
    $t.='>'.$f.$q.$e;
  } return ['value'=>$n,'text'=>$m,'options'=>$t];
}
}
