<?php
//Fast Site Engine. Copyright © AC (acwed@ya.ru), 2004-2023. All rights reserved. 2-clause BSD license.
//exec("unzip -x i.zip");
include '../validate.php';
$dir='../../deny/fsebackup';
$adir='../../deny';
$bdir='../../inc/tpl';
if(''==$sys['name'])$sys['name']=str_replace('www.','',$_SERVER['SERVER_NAME']);
function testfile($fe,$txt){
  if(is_file($fe)) return;
  $f=fopen($fe,'w');
  fputs($f,$txt);
  fclose($f);
}
function makedir($n){
  if(!is_dir($n)){
    mkdir($n,0755,1);
    testfile($n.'.htaccess','Deny from ALL');
    Logme('MakeDir'.$n);
  }
}
makedir($adir);
makedir($bdir.'/inc');
if(isset($_POST['do'])){
  $do=unecran(HPOST('do'));
  if('create'==$do){
    if(!is_dir($dir))mkdir($dir,0755,1);
    function addFolderToZip($d,$z,$dir=''){
      if(!is_dir($d) || !$o=opendir($d))return;
      while(false!==($f=readdir($o))){
        $n=$d.'/'.$f;
        $l=$dir.'/'.$f;
        if(is_file($n)){
          if(''!=$dir)$z->addFile($n,$l);
          else $z->addFile($n,'/'.$f);
        }elseif(is_dir($n) && $f!='.' && $f!='..' && $f!='fsebackup'){
          $z->addEmptyDir($dir.$f);
          addFolderToZip($n,$z,$l);
        }
      } closedir($o);
    }
    $t=$sys['name'].'_'.date('Ymd-His').'_fse';
    if(is_file($dir.'/'.$t)){
      $j=1;while(is_file($dir.'/'.$t.$j.'.zip'))++$j;
      $t.=$j;
    } $t=$dir.'/'.$t.'.zip';
    $zip=new ZipArchive;
    if($e=$zip->open($t,ZipArchive::CREATE)===true){
      addFolderToZip($adir,$zip,'deny');
      addFolderToZip($bdir,$zip,'inc/tpl');
    } $zip->close();
    Logme('Create backup: '.$t);
    echo '<input id="needreboot" type="hidden" value="">';
  }elseif('del'==$do){
    removedir($dir);
    Logme('Delete backups');
    echo '<input id="needreboot" type="hidden" value="">';
  }elseif('restore'==$do){
    if(!isset($_POST['val']))exit;
    $val=unecran(HPOST('val'));
    function rembdir($d){
      if(!is_dir($d) || !$o=opendir($d))return;
      while(false!==($f=readdir($o))){
        $n=$d.'/'.$f;
        if(is_file($n))unlink($n);
        elseif(is_dir($n) && $f!='.' && $f!='..' && $f!='fsebackup')rembdir($n);
      } closedir($o);
      //rmdir($d);
    }
    $zip=new ZipArchive;
    if($e=$zip->open($val)===true){
      rembdir($adir);
      removedir($bdir);
      $zip->extractTo('../../');
      $zip->close();
    }else exit('Error:'.$e);
    Logme('Restore backup: '.$val);
    echo '<input id="needreboot" type="hidden" value="">';
  } return;
}
include '../_inc/func.php';
$lt=$lng['backup'];
$a=[];
function bytes($b){
  $a=['B','KB','MB','GB','TB','PB'];
  $i=0;while($b>=1024){$b/=1024;++$i;}
  return round($b,2).$a[$i];
}
function ex($s){
  $s=mb_substr(mb_strrchr($s,'.'),1);
  $s=mb_strtolower($s);
  return $s;
}
function readf($d){
  global $a;
  if(!is_dir($d) || !$o=opendir($d))return;
  while(false!==($f=readdir($o))){
    $n=$d.'/'.$f;
    if(is_file($n))$a[]=$n;
    elseif(is_dir($n) && $f!='.' && $f!='..' && $f!='fsebackup')readf($n);
  } closedir($o);
}
function backups($d){
  if(!is_dir($d) || !$o=opendir($d))return;
  while(false!==($f=readdir($o))){
    $n=$d.'/'.$f;
    if(is_file($n) && 'zip'==ex($n))echo '<br><br>'.$f.
      ' &nbsp; &nbsp; &nbsp;<input type="button" value="'.ll('download').'" onclick="download(\''.$n.'\')"> &nbsp; &nbsp; &nbsp;
      <input type="button" value="'.ll('restore').'" onclick="restore(this,\''.$n.'\')">';
  } closedir($o);
} 
readf($adir);
readf($bdir);
$size=0;
$sa=sizeof($a);
for($i=0;$i<$sa;$i++)$size+=filesize($a[$i]);
if(isset($_FILES['userfile'])){
  $iszip=('zip'==ex($_FILES['userfile']['name']));
  if(!$iszip) echo '<div style="border:1px solid red">'.$_FILES['userfile']['name'].' - '.ll('notallowed').' zip</div>';
  else{
    if(!is_dir($dir))mkdir($dir,0755,1);
    if(move_uploaded_file($_FILES['userfile']['tmp_name'],$dir.'/'.$_FILES['userfile']['name']))
      echo '<div style="width:600px;margin:0 auto;border:1px solid green;text-align:center"><br>'.$_FILES['userfile']['name'].' - '.ll('loaded').'<br><br></div><br><br><script>'.N.
      'setTimeout("document.location=\'\'",3000);'.N.'</script>';
  }
}
echo '<table style="margin:0 auto"><tr><td>'.ll('txt').' <small>( '.$adir.', '.$bdir.' )</small><br><br>'.
  ll('structure').': '.bytes($size).' &nbsp;&nbsp; '.$sa.ll('files').'<br><br>'.
  '<input type="button" value="'.ll('create').'" onclick="create(this)"><br><hr><br>'.ll('finded');
backups($dir);
echo '<br><br><br><br><hr>
  <form action="index.php" method="post" ENCTYPE="multipart/form-data">
    <table style="margin:0 auto">
      <tr><td><input type="file" size="80" name="userfile"></td><td style="width:20px"></td><td><input type="submit" value="'.ll('load').' (.zip)"></td></tr>
    </table>
  </form><br><br><br><br><br><table style="margin:0 auto"><tr><td><input style="margin:0 auto" type="button" value="'.ll('del').'" onclick="delb(this)"></td></tr></table>';
?>
<script>
var ob;
function showbt(){
  ob.style.display='';
}
function download(v){
  document.location='download.php?v='+v;
}
function create(o){
  ob=o;
  o.style.display='none';
  makeRequest('index','do=create','resul_t');
  setTimeout("showbt()",10000);
}
function restore(o,v){
  ob=o;
  o.style.display='none';
  makeRequest('index','do=restore&val='+ecr(v),'resul_t');
  setTimeout("showbt()",10000);
}
function delb(o){
  ob=o;
  o.style.display='none';
  makeRequest('index','do=del','resul_t');
  setTimeout("showbt()",10000);
}
</script>
</td></tr></table></body></html>