<?php
//Fast Site Engine. Copyright © AC (acwed@ya.ru), 2004-2023. All rights reserved. 2-clause BSD license.
error_reporting(~E_WARNING);//filesize==0 warrings off
date_default_timezone_set('Europe/Moscow');
require '../../../../../inc/tpl/inc/_sys.php';
require '../../../../../inc/tpl/inc/_keys.php';
session_start();
function s($name,$value=''){
  global $sesname;
  if(''==$value)return isset($_SESSION['AC'.$sesname][$name])?$_SESSION['AC'.$sesname][$name]:false;
  $_SESSION['AC'.$sesname][$name]=$value;
}
function logout(){
  global $sesname;
  unset($_SESSION['AC'.$sesname]);//session_destroy();
  header('Location: ../../../../');
} if(!s('admname') || isset($_GET['exit']))logout();
function tabi(){
  static $i=0;++$i;return ' tabindex="'.$i.'"';
}
$l=s('lang');
if(isset($sys['lang'][$l]))define('Li',$l);
else{
  foreach($sys['lang'] as $k=>$v){$l=$k;break;}
  define('Li',$l);
} $lf=Li.'.php';
if(is_file($lf))include $lf;
else exit('<code role="alert"'.tabi().'>Error: lang file not found ('.$lf.')</code>');
define('N',"\n");
define('RP','inc/');//root
define('P','../../../../../'.RP);//for links
define('R',realpath(P).'/');//root path
define('RD',mb_substr(strrchr(mb_substr(R,0,-1),'/'),1));//root dir name
define('TD',R.'_thumb/');//thumbnail previews
define('TP',P.'_thumb/');//for links
define('T',$_SERVER['REQUEST_TIME']);
define('SNAME',str_replace('www.','',$_SERVER['SERVER_NAME']));
$c['afmr']=!(int)c('afmr');//Заменять файлы при загрузке
$c['afmn']=!(int)c('afmn');//Имена в нижний регистр
$c['afmt']=!(int)c('afmt');//Транслит имён
function sp($s,$f){
  return false!==mb_strpos($s,$f)?1:0;
}
function c($n){
  return isset($_COOKIE[$n])?htmlspecialchars($_COOKIE[$n],ENT_QUOTES):false;
}
function sc($n,$s='',$t=-1){
  if(''!=$s)$t=2592000;
  setcookie($n,$s,T+$t,'/',SNAME,0);
}
function bytes($b){
  $a=['B','KB','MB','GB','TB','PB'];
  $i=0;while($b>=1024){$b/=1024;++$i;}
  return round($b,2).$a[$i];
}
function maxsize($s){
  $s=strtolower($s);
  $i=(int)$s;
  if(sp($s,'k'))$i=$i*1024;
  elseif(sp($s,'m'))$i=$i*1048576;
  elseif(sp($s,'g'))$i=$i*1073741824;
  return $i;
}
function une($v){
  return str_replace(['`~','`^'],['&','+'],stripslashes($v));
}
function remdir($d){
  if(!is_dir($d) || !$o=opendir($d))return;
  $t=str_replace(R,TD,$d);
  while(false!==($f=readdir($o))){
    $n=$d.'/'.$f;
    $p=$t.'/'.$f;
    if(is_file($n)){
      unlink($n);
      if(is_file($p))unlink($p);
    }elseif(is_dir($n) && $f!='.' && $f!='..'){
      remdir($n);
      if(is_dir($p))remdir($p);
    }
  } closedir($o);
  rmdir($d);
  if(is_dir($p))remdir($p);
}
function ex($s,$l=0){
  global $c;
  $s=mb_substr(strrchr($s,'.'),1);
  if($l || $c['afmn'])$s=mb_strtolower($s);
  return $s;
}
function bn($s,$e=''){
  $s=preg_replace('#/+$#','',$s);
  $a=explode('/',$s);$s=end($a);//basename($s,$e)-->имя-1.xxx=-1.xxx
  if(''!=$e)$s=mb_substr($s,0,-mb_strlen($e));
  return $s;
}
function safep($s){
  $s=str_replace(['../','./','//','#'],'',une($s));
  return preg_replace('#^'.RP.'#','',$s);
}
function safename($s,$d=0){
  if(!$d)$s=str_replace('/','',$s);
  $s=str_replace([' ','_'],'-',trim($s));//both      //win   //*nux
  return str_replace(['*','"','\\',':','<','>','|','?','!','@','#','$','&','~','%','(',')','[',']','{','}','\'',';','`','='],'',$s);
}                                        //for old engines
$hide=['styles'=>1,'_thumb'=>1,'mods'=>1,'1'=>1,'2'=>1,'3'=>1,'4'=>1,'backup'=>1,'cach'=>1,'inc'=>1,'tpl'=>1];//from root
$deny=['htaccess'=>1,'php'=>1,'js'=>1,'ascx'=>1,'asp'=>1,'aspx'=>1,'cfc'=>1,'cfm'=>1,'cgi'=>1,'jsp'=>1,'php3'=>1,'php4'=>1,'php5'=>1,'phtml'=>1,'pl'=>1];
$frmti=[1=>'gif',2=>'jpg',3=>'png',4=>'swf',5=>'psd',6=>'bmp',7=>'tiff',8=>'tiff',9=>'jpc',10=>'jp2',11=>'jpx'];//тип изображения:getimagesize 7-(INTEL) 8-(MOTOROLA)
if(isset($_GET['updir'])){
  $d=safep($_GET['updir']);
  if(!is_dir(R.$d)){
    header('HTTP/1.1 500 Internal Server Error');
    exit('<code role="alert"'.tabi().'>'.$l['dirnotf'].'</code>');
  }
  $n=safename($_GET['upname']);
  $e=ex($n);
  $b=bn($n,'.'.$e);
  if(''==$b || isset($deny[mb_strtolower($e)]))exit(' ');
  if(isset($_GET['upfrom'])){
    $m=((int)$_GET['upfrom']==0)?'wb':'ab';
    if(!$f=fopen(R.$d.$n.'.load',$m)){
      header('HTTP/1.1 500 Internal Server Error');
      exit('<code role="alert"'.tabi().'>'.$l['unableopen'].'</code>');
    }
    if($fi=fopen('php://input','rb')){
      while(!feof($fi)){
        $fr=fread($fi,1048576);//1024*1024=1mb
        fwrite($f,$fr);
      } fclose($fi);
    }
    fclose($f);
    return;
  }
  if(isset($_GET['done'])){
    if($c['afmr'] || !is_file(R.$d.$n)){rename(R.$d.$n.'.load',R.$d.$n);return;}
    $j=1;while(is_file(R.$d.$b.'-'.$j.'.'.$e))++$j;
    rename(R.$d.$n.'.load',R.$d.$b.'-'.$j.'.'.$e);
    $p=TD.$d.$b.'-'.$j.'.'.$e;
    if(is_file($p))unlink($p);
    return;
  }//elseif(isset($_GET['cancel'])){if(is_file(R.$d.$n.'.load'))unlink(R.$d.$n.'.load');return;}
}
if(isset($_POST['before'])){
  $d=safep($_POST['before']);
  if(!is_dir(R.$d)){
   exit('<code role="alert"'.tabi().'>'.$l['dirnotf'].'</code>');
 } $o='';
  $n=explode('`',une($_POST['n']));
  $s=explode('`',une($_POST['s']));
  $size=sizeof($n);
  for($i=0;$i<$size;++$i){
    if(''==$n[$i])continue;
    $t=safename($n[$i]);
    $e=ex($t);
    if(isset($deny[mb_strtolower($e)])){$o.='<li role="alert"'.tabi().'>'.$n[$i].' <b>'.$l['fskipped'].' <small>('.$l['prohibited'].')</small></b></li>';continue;}
    $b=bn($t,'.'.$e);
    if($c['afmn'])$b=mb_strtolower($b);
    if($c['afmt'])$b=translate($b);
    if(''==$b)$b=microtime(1);
    if($c['afmr'] || !is_file(R.$d.$b.'.'.$e))$t=$b.'.'.$e;
    else{
      $j=1;while(is_file(R.$d.$b.'-'.$j.'.'.$e))++$j;
      $t=$b.'-'.$j.'.'.$e;
    }
    $f=R.$d.$t.'.load';
    $start=is_file($f)?filesize($f):0;
    $t=($t!=$n[$i])?'<s>'.$n[$i].'</s><br><em>'.$t.'</em>':'<em>'.$t.'</em>';
    $o.='<li'.tabi().'>'.$t.' <small>('.bytes($s[$i]).')</small><code><progress value="0" max="100"></progress><pre'.tabi().'>0%</pre></code><q>'.$start.'</q></li>';
  }exit('<ul>'.$o.'</ul><button class="ab" onclick="rh()"'.tabi().'>'.$l['refresh'].'</button><input type="hidden" id="eval" value="upl.go()">');
}
$reboot='<input type="hidden" id="reboot" value="">';
function addFolderToZip($lvl,$d,$z,$dir=''){
  global $hide,$deny,$q,$l;
  if(!is_dir($d) || !$o=opendir($d))return;
  while(false!==($r=readdir($o))){
    if('.'==$r || '..'==$r)continue;
    if(is_dir($d.$r)){
      if(0==$lvl && isset($hide[$r])){echo '<code role="alert"',tabi(),'>',$l['dskipped'],' <small>(',$l['prohibited'],')</small>: ',RP,$q,$r,'</code><br>';continue;}
      $z->addEmptyDir($dir.$r);
      addFolderToZip($lvl+1,$d.$r.'/',$z,$dir.$r.'/');
    }else{
      if(isset($deny[ex($r,1)])){echo '<code role="alert"',tabi(),'>',$l['fskipped'],' <small>(',$l['prohibited'],')</small>: ',RP,$q,$r,'</code><br>';continue;}
      elseif(''!=$dir)$z->addFile($d.$r,$dir.$r);
      else $z->addFile($d.$r,'/'.$r);
    }
  } closedir($o);
}
function copydir($d,$to){
  if(!is_dir($d) || !$o=opendir($d))return;
  if(!is_dir($to))mkdir($to,0755,1);
  while(false!==($r=readdir($o))){
    if('.'==$r || '..'==$r)continue;
    $p=str_replace(R,TD,$to.'/'.$r);
    if(is_dir($d.'/'.$r)){
      copydir($d.'/'.$r,$to.'/'.$r);
      if(is_dir($p))remdir($p);
    }else{
      copy($d.'/'.$r,$to.'/'.$r);
      if(is_file($p))unlink($p);
    }
  } closedir($o);
}
$c['afmq']=c('afmq');//последняя папка
if(isset($_POST['gopath'])){
  $d=safep($_POST['gopath']);
  if(isset($_POST['gomkdir']) && !is_dir(R.$d))mkdir(R.$d,0755,1);
  if(isset($_POST['goimg'])){
    $d='img/'.$d;
    if(!is_dir(R.$d))mkdir(R.$d,0755,1);
  } $a=explode('/',$d);
  if(RD==$a[0])unset($a[0]);
  $qnum=0;
  $q=[];foreach($a as $k=>$v)if(''!=$v){$q[]=$v;$qnum++;}
  if(!isset($q[0])){//go root
    if($c['afmq'])sc('afmq');
    exit('<input type="hidden" id="navigate" value="?q=0">');
  } for($i=0;$i<20;++$i)if(!isset($q[$i]))$q[$i]='';
  if(isset($hide[$q[0]]))exit('<code role="alert"'.tabi().'>'.$l['dbrowforb'].'</code>');
  $dirs='';
  $num=0;
  function dirstonum($d,$lvl=0,$p=''){
    global $dirs,$q,$hide,$num;
    if(!is_dir($d) || !$o=opendir($d))return;
    if(''!=$p)$p.='-';
    $a=[];
    while(false!==($r=readdir($o))){
      if('.'==$r || '..'==$r || (0==$lvl && isset($hide[$r])) || !is_dir($d.$r))continue;
      $a[$r]=1;
    } closedir($o);
    ksort($a,SORT_NATURAL);//SORT_LOCALE_STRING
    $i=0;
    foreach($a as $k=>$v){
      ++$i;
      if($q[$lvl]==$k){//open
        $num++;
        $dirs=$p.$i;
        dirstonum($d.$k.'/',$lvl+1,$p.$i);
        break;
      }
    }
  } dirstonum(R);
  if($qnum==$num){
    if(''==$dirs)$dirs='0';
    exit('<input type="hidden" id="navigate" value="?q='.$dirs.'">');
  }else exit('<code role="alert"'.tabi().'>'.$l['nopath'].date(' H:i:s',T).'</code>');
}elseif(isset($_POST['repl'])){//заменить
  $cut=explode('`',une($_POST['repl']));
  $s=explode('`',une($_POST['s']));
  $d=explode('`',une($_POST['d']));
  $size=sizeof($cut);
  for($i=0;$i<$size;++$i){
    if(''==$cut[$i])continue;
    $p=str_replace(R,TD,$d[$i]);
    if(is_dir($s[$i])){
      if((int)$cut[$i]){
        rename($s[$i],$d[$i]);
        if(is_dir($p))remdir($p);
      }else copydir($s[$i],$d[$i]);
    }else{
      if((int)$cut[$i])rename($s[$i],$d[$i]);
      else copy($s[$i],$d[$i]);
      if(is_file($p))unlink($p);
    } $s=($size>1)?';replcl();replcl()':'';
  }exit('<input type="hidden" id="eval" value="replo.parentNode.innerHTML=\''.$l['replaced'].'<br>\''.$s.'">');
}elseif(isset($_POST['paste'])){//5 Вставить
  $d=safep($_POST['paste']);
  $to=safep($_POST['to']);
  $a=explode('`',une($_POST['names']));
  $cut=(int)$_POST['cut'];
  $lvl=(''==$to)?0:1;$t=0;$c=$s=$n='';
  foreach($a as $k=>$v){
    if(''==$v)continue;
    if(is_dir(R.$d.$v)){
      if(0==$lvl && isset($hide[$v])){echo '<code role="alert"',tabi(),'>',$l['dskipped'],' <small>(',$l['prohibited'],')</small>: ',RP,$d,$v,'</code><br>';$t=1;continue;}
      if(sp(R.$to.$v,R.$d.$v)){echo '<code role="alert"',tabi(),'>',$l['itself'],': ',RP,$d,$v,' --> ',RP,$to,$v,'</code><br>';$t=1;continue;}
      if(is_dir(R.$to.$v)){
        echo '<code role="alert"',tabi(),'>',$l['dexists'],': ',RP,$d,$v,' --> ',RP,$to,$v,' <button class="ab" onclick="repl(this,\'',$cut,'\',\'',R,$d,$v,'\',\'',R,$to,$v,'\')"',tabi(),'>',$l['replace'],'</button></code><br>';
        $c.='`'.$cut;$s.='`'.R.$d.$v;$n.='`'.R.$to.$v;
        $t=1;continue;
      }
      if($cut){
        rename(R.$d.$v,R.$to.$v);
        $p=TD.$d.$v;if(is_dir($p))remdir($p);
        $p=TD.$to.$v;if(is_dir($p))remdir($p);
      }else copydir(R.$d.$v,R.$to.$v);
    }elseif(is_file(R.$d.$v)){
      if(isset($deny[ex($v,1)])){echo '<code role="alert"',tabi(),'>',$l['fskipped'],' <small>(',$l['prohibited'],')</small>: ',RP,$d,$v,'</code><br>';$t=1;continue;}
      if(is_file(R.$to.$v)){
        echo '<code role="alert"',tabi(),'>',$l['fexists'],': ',RP,$d,$v,' --> ',RP,$to,$v,' <button class="ab" onclick="repl(this,\'',$cut,'\',\'',R,$d,$v,'\',\'',R,$to,$v,'\')"',tabi(),'>',$l['replace'],'</button></code><br>';
        $c.='`'.$cut;$s.='`'.R.$d.$v;$n.='`'.R.$to.$v;
        $t=1;continue;
      }
      if($cut)rename(R.$d.$v,R.$to.$v);
      else copy(R.$d.$v,R.$to.$v);
      $p=TD.$d.$v;if(is_file($p))unlink($p);
      $p=TD.$to.$v;if(is_file($p))unlink($p);
    }
  } if(''!=$c)echo '<h3><button class="ab" onclick="repl(this,\'',$c,'\',\'',$s,'\',\'',$n,'\')"',tabi(),'>',$l['replaceall'],'</button></h3>';
  if($t)exit('<code role="alert"'.tabi().'><button class="ab" onclick="rh()"'.tabi().'>'.$l['refresh'].'</button></code>');
  exit($reboot);
}elseif(isset($_POST['deld'])){//7 удалить папку клик слева
  $d=safep($_POST['deld']);
  if(''==$d)exit('<code role="alert"'.tabi().'>'.$l['notallowed'].'</code>');//рут
  remdir(R.$d);
  $p=TD.$d;if(is_dir($p))remdir($p);
  exit($reboot);
}elseif(isset($_POST['delf'])){//7 удалить клик справа || del
  $d=safep($_POST['path']);
  $lvl=(''==$d)?0:1;$t=0;
  $a=explode('`',une($_POST['delf']));
  foreach($a as $k=>$v){
    if(''==$v)continue;
    if(''==$d)$v=safep($v);
    if(is_dir(R.$d.$v)){
      if(0==$lvl && isset($hide[$v])){echo '<code role="alert"',tabi(),'>',$l['dskipped'],' <small>(',$l['prohibited'],')</small>: ',RP,$d,$v,'</code><br>';$t=1;continue;}
      remdir(R.$d.$v);//проверка глубже не нужна - скрипты только в корне..
    }elseif(is_file(R.$d.$v)){
      if(isset($deny[ex($v,1)])){echo '<code role="alert"',tabi(),'>',$l['fskipped'],' <small>(',$l['prohibited'],')</small>: ',RP,$d,$v,'</code><br>';$t=1;continue;}
      else{
        unlink(R.$d.$v);
        $p=TD.$d.$v;if(is_file($p))unlink($p);
      }
    }
  } if($t)exit('<code role="alert"'.tabi().'><button class="ab" onclick="rh()"'.tabi().'>'.$l['refresh'].'</button></code>');
  exit($reboot);
}elseif(isset($_POST['rename'])){//8 Переименовать
  $d=safep($_POST['rename']);
  if(''==$d)exit('<code role="alert"'.tabi().'>'.$l['notallowed'].'</code>');//рут
  $o=explode('`',une($_POST['old']));
  $n=explode('`',trim(une($_POST['new'])));
  $size=sizeof($o);$t=0;
  for($i=0;$i<$size;++$i){
    $n[$i]=safename($n[$i]);
    if(''==$n[$i] || $o[$i]==$n[$i])continue;
    if(is_file(R.$d.$o[$i])){
      if(is_file(R.$d.$n[$i])){echo '<code role="alert"',tabi(),'>',$l['file'],' ',$l['rcanceled'],': ',RP,$d,$o[$i],' --> ',RP,$d,$n[$i],'</code><br>';$t=1;}
      elseif(isset($deny[ex($n[$i],1)])){echo '<code role="alert"',tabi(),'>'.$l['fskipped'].' <small>(',$l['prohibited'],')</small>: ',RP,$d,$o[$i],' --> ',RP,$d,$n[$i],'</code><br>';$t=1;}
      else{
        rename(R.$d.$o[$i],R.$d.$n[$i]);
        $p=TD.$d.$o[$i];if(is_file($p))rename($p,TD.$d.$n[$i]);
      }
    }elseif(is_dir(R.$d.$o[$i])){
      if(is_dir(R.$d.$n[$i])){echo '<code role="alert"',tabi(),'>',$l['folder'],' ',$l['rcanceled'],': ',RP,$d,$o[$i],' --> ',RP,$d,$n[$i],'</code><br>';$t=1;}
      else{
        rename(R.$d.$o[$i],R.$d.$n[$i]);
        $p=TD.$d.$o[$i];if(is_dir($p))rename($p,TD.$d.$n[$i]);
      }
    }else{echo '<code role="alert"',tabi(),'>',$l['nosource'],': ',RP,$d,$o[$i],'</code><br>';$t=1;}
  } if($t)exit('<code role="alert"'.tabi().'><button class="ab" onclick="rh()"'.tabi().'>'.$l['refresh'].'</button></code>');
  exit($reboot);
}elseif(isset($_POST['case'])){//9 Сменить регистр
  $d=safep($_POST['case']);
  if(''==$d)exit('<code role="alert"'.tabi().'>'.$l['notallowed'].'</code>');//рут
  $n=explode('`',une($_POST['names']));
  foreach($n as $k=>$v){
    if(''==$v)continue;
    if(is_dir(R.$d.$v)){
      $size=mb_strlen($v);$up=0;
      for($i=0;$i<$size;$i++)if(ctype_upper($v[$i])){$up=1;break;}
      $t=$up?mb_strtolower($v):mb_strtoupper($v);
      if(is_dir(R.$d.$t)){
        $j=1;while(is_dir(R.$d.$t.'-'.$j))++$j;
        $t.='-'.$j;
      } rename(R.$d.$v,R.$d.$t);
      $p=TD.$d.$v;if(is_dir($p))rename($p,TD.$d.$t);
    }else{
      $e=ex($v);
      $b=bn($v,'.'.$e);
      $e=mb_strtolower($e);
      $size=mb_strlen($b);$up=0;
      for($i=0;$i<$size;$i++)if(ctype_upper($b[$i])){$up=1;break;}
      $t=$up?mb_strtolower($b):mb_strtoupper($b);
      if(is_file(R.$d.$t.'.'.$e)){
        $j=1;while(is_file(R.$d.$t.'-'.$j.'.'.$e))++$j;
        $t.='-'.$j;
      } rename(R.$d.$v,R.$d.$t.'.'.$e);
      $p=TD.$d.$v;if(is_file($p))rename($p,TD.$d.$t);
    }
  } exit($reboot);
}elseif(isset($_POST['fix'])){//10 Исправить расширение
  $d=safep($_POST['fix']);
  $n=explode('`',une($_POST['names']));
  foreach($n as $k=>$v){
    if(''==$v || !is_file(R.$d.$v))continue;
    $e=ex($v);
    $a=getimagesize(R.$d.$v);
    if(mb_strtolower($e)!=$frmti[$a[2]]){
      $b=bn($v,'.'.$e);
      if(is_file(R.$d.$b.'.'.$frmti[$a[2]])){
        $j=1;while(is_file(R.$d.$b.'-'.$j.'.'.$frmti[$a[2]]))++$j;
        $b.='-'.$j;
      } rename(R.$d.$v,R.$d.$b.'.'.$frmti[$a[2]]);
      $p=TD.$d.$v;if(is_file($p))rename($p,TD.$d.$b.'.'.$frmti[$a[2]]);
    }
  } exit($reboot);
}elseif(isset($_POST['mkdir'])){//11 Создать папку
  $d=safep($_POST['mkdir']);
  $n=safename(une($_POST['name']));
  if($c['afmt'])$n=translate($n);
  if(''!=$n && !is_dir(R.$d.$n)){mkdir(R.$d.$n,0755,1);exit($reboot);}
  else exit('<code role="alert"'.tabi().'>'.$l['notcreated'].'.<button class="ab" onclick="rh()"'.tabi().'>'.$l['refresh'].'</button></code>');
}elseif(isset($_POST['zipd'])){//12 Упаковать в zip клик слева
  $q=safep($_POST['zipd']);
  if(''==$q)exit('<code role="alert"'.tabi().'>'.$l['notallowed'].'</code>');//рут
  $d=R.$q;if(!is_dir($d))exit('<code role="alert"'.tabi().'>'.$l['dirnotf'].'</code>');
  $n=mb_substr($d,0,-1);
  if(is_file($n.'.zip')){
    $j=1;while(is_file($n.'-'.$j.'.zip'))++$j;
    $n.='-'.$j;
  } $n.='.zip';
  $zip=new ZipArchive;
  if($e=$zip->open($n,ZipArchive::CREATE)===true){
    $lvl=R==$d?0:1;
    addFolderToZip($lvl,$d,$zip);
    $zip->close();
    if(is_file($n)){
      $a=explode('/',mb_substr($q,0,-1));
      $size=sizeof($a);$s='';
      for($i=0;$i<$size-1;++$i)$s.=$a[$i].'/';
      $n=RP.$s.bn($n);
      exit('<code role="alert"'.tabi().'>'.$l['archcred'].': '.$n.' &nbsp; <a class="ab" href="../../../../../'.$n.'" target="_blank" download'.tabi().'>'.$l['download'].'</a> &nbsp; <button class="ab" onclick="ff.send(\'index\',\'delf=\'+ff.e(\''.bn($n).'\')+\'&path=\'+ff.e(\''.$s.'\'),\'df\')"'.tabi().'>'.$l['delete'].'</button></code>');
    }else exit('<code role="alert"'.tabi().'>'.$l['archnof'].'.<button class="ab" onclick="rh()"'.tabi().'>'.$l['refresh'].'</button></code><br>');
  }else exit('<code role="alert"'.tabi().'>'.$l['archerr'].' №'.$e.'</code><br>');
}elseif(isset($_POST['zip'])){//12 Упаковать в zip
  $d=safep($_POST['zip']);
  $n=explode('`',une($_POST['names']));
  $t=R.$d.bn(R.$d);
  if(is_file($t.'.zip')){
    $j=1;while(is_file($t.'-'.$j.'.zip'))++$j;
    $t.='-'.$j;
  } $t.='.zip';
  $zip=new ZipArchive;
  if($e=$zip->open($t,ZipArchive::CREATE)===true){
    $lvl=R==R.$d?0:1;
    foreach($n as $k=>$v){
      if(''==$v)continue;
      if(is_dir(R.$d.$v)){
        if(0==$lvl && isset($hide[$v])){echo '<code role="alert"',tabi(),'>',$l['dskipped'],' <small>(',$l['prohibited'],')</small>: ',RP,$d,$v,'</code><br>';continue;}
        $zip->addEmptyDir($v);
        addFolderToZip($lvl+1,R.$d.$v.'/',$zip,$v.'/');
      }else{
        if(isset($deny[ex($v,1)])){echo '<code role="alert"',tabi(),'>',$l['fskipped'],' <small>(',$l['prohibited'],')</small>: ',RP,$d,$v,'</code><br>';}
        else $zip->addFile(R.$d.$v,'/'.$v);//$zip->addFromString('test.txt','строка-содержимое файла');
      }
    } $zip->close();
    if(is_file($t)){
      $n=RP.$d.bn($t);
      exit('<code role="alert"'.tabi().'>'.$l['archcred'].': '.$n.' &nbsp; <a class="ab" href="../../../../../'.$n.'" target="_blank" download'.tabi().'>'.$l['download'].bn(R.$d).'</a> &nbsp; <button class="ab" onclick="ff.send(\'index\',\'delf=\'+ff.e(\''.bn($t).'\')+\'&path=\'+ff.e(\''.$d.'\'),\'df\')"'.tabi().'>'.$l['delete'].'</button></code>');
    }else exit('<code role="alert"'.tabi().'>'.$l['archnof'].'.<button class="ab" onclick="rh()"'.tabi().'>'.$l['refresh'].'</button></code>');
  }else exit('<code role="alert"'.tabi().'>'.$l['archerr'].' №'.$e.'</code>');
}elseif(isset($_POST['unzip'])){//13 Распаковать zip
  $d=safep($_POST['unzip']);
  $n=explode('`',une($_POST['names']));
  $lvl=R==R.$d?0:1;
  $t=0;
  $a=[];
  foreach($n as $k=>$v){
    if(''==$v)continue;
    $zip=new ZipArchive;
    if($e=$zip->open(R.$d.$v)===true){
      for($j=0;$j<$zip->numFiles;$j++){
        $r=$zip->getNameIndex($j);//print_r($zip->statIndex($j));
        if('/'==mb_substr($r,-1)){//isDir
          if(0==$lvl && isset($hide[mb_substr($r,0,-1)])){echo '<code role="alert"',tabi(),'>',$l['dskipped'],' <small>(',$l['prohibited'],')</small>: ',$r,'<br></code>';$t=1;}
          else $a[]=$r;
        }else{
          if(0==$lvl && sp($r,'/')){
            $b=explode('/',$r);
            if(isset($hide[$b[0]]))continue;
          } if(isset($deny[ex($r,1)])){echo '<code role="alert"',tabi(),'>',$l['fskipped'],' <small>(',$l['prohibited'],')</small>: ',$r,'</code><br>';$t=1;}else $a[]=$r;
        }//$zip->extractTo('/destination/dir/',['file1.gif','file2.gif']);
      } $zip->extractTo(R.$d,$a);
      $zip->close();
    }else{echo '<code role="alert"',tabi(),'>',$l['archoerr'],' №',$e,'</code>';$t=1;}
  } if($t)exit('<code role="alert"'.tabi().'><button class="ab" onclick="rh()"'.tabi().'>'.$l['refresh'].'</button></code>');
  exit($reboot);
}
function fext($e){
  $one=['bmp'=>1,'css'=>1,'csv'=>1,'gif'=>1,'js'=>1,'pdf'=>1,'php'=>1,'psd'=>1,'xml'=>1,'zip'=>1];
  $jpg=['jpg'=>1,'jpeg'=>1];
  $png=['png'=>1,'tiff'=>1];
  $doc=['doc'=>1,'docx'=>1,'odt'=>1,'rtf'=>1];
  $xls=['ods'=>1,'xls'=>1,'xlsx'=>1];
  $html=['htm'=>1,'html'=>1];
  $archive=['7z'=>1,'arc'=>1,'arj'=>1,'bcm'=>1,'bz2'=>1,'cab'=>1,'gz'=>1,'pea'=>1,'rar'=>1,'tar'=>1,'wim'=>1,'xz'=>1,'zpaq'=>1];
  $audio=['ac3'=>1,'ape'=>1,'flac'=>1,'mid'=>1,'mp3'=>1,'ogg'=>1,'wav'=>1,'wma'=>1,'aac'=>1];
  $video=['3gp'=>1,'asf'=>1,'avi'=>1,'mkv'=>1,'mov'=>1,'mp4'=>1,'mpeg'=>1,'mpg'=>1,'wmv'=>1];
  $font=['dfont'=>1,'eot'=>1,'fnt'=>1,'fon'=>1,'otf'=>1,'svg'=>1,'tte'=>1,'ttf'=>1,'woff'=>1];
  //$a=$xls;ksort($a);$s='';foreach($a as $k=>$v)$s.='\''.$k.'\'=>1,';$s='['.mb_substr($s,0,-1).'];';exit($s);
  foreach($one as $k=>$v)if($e==$k)return $k;
  if(isset($jpg[$e]))return 'jpg';
  if(isset($png[$e]))return 'png';
  if(isset($doc[$e]))return 'doc';
  if(isset($xls[$e]))return 'xls';
  if(isset($html[$e]))return 'html';
  if(isset($archive[$e]))return 'archive';
  if(isset($audio[$e]))return 'audio';
  if(isset($video[$e]))return 'video';
  if(isset($font[$e]))return 'font';
  return 'file';
}
$q=isset($_GET['q'])?$_GET['q']:$c['afmq'];
$q=safename($q);
$q=explode('-',$q);
for($i=0;$i<20;++$i)if(!isset($q[$i]))$q[$i]='';
$patht='';
$pathn='';
$pathb='<button onclick="go(0)" title="'.$l['gotodir'].' '.RD.'">'.RD.'</button> <i>/</i> ';
$dirs='<ul class="no"><li><button onclick="go(0)">'.RD.'</button><ul>';
function dirs($d,$lvl=0,$p=''){
  global $dirs,$q,$hide,$pathb,$patht,$pathn,$l;
  if(!is_dir($d) || !$o=opendir($d))return;
  if(''!=$p)$p.='-';
  $a=[];
  while(false!==($r=readdir($o))){
    if('.'==$r || '..'==$r || (0==$lvl && isset($hide[$r])) || !is_dir($d.$r))continue;
    $a[$r]=1;
  } closedir($o);
  ksort($a,SORT_NATURAL);
  $i=0;
  foreach($a as $k=>$v){
    ++$i;
    if($q[$lvl]==$i){//open
      $dirs.='<li class="lon"><button class="bon" onclick="go(\''.$p.$i.'\')" title="'.$l['enabled'].'">'.$k.'</button>';
      $pathb.='<button onclick="go(\''.$p.$i.'\')">'.$k.'</button> <i>/</i> ';
      $patht.=$k.'/';
      $dirs.='<ul>';
      $pathn=$p.$i;
      dirs($d.$k.'/',$lvl+1,$p.$i);
      $dirs.='</ul>';
    } else $dirs.='<li><button onclick="go(\''.$p.$i.'\')">'.$k.'</button>';
    $dirs.='</li>';
  }
} dirs(R);
$dirs.='</ul></li></ul>';
if($c['afmq']!=$pathn)sc('afmq',$pathn);
if(isset($_GET['q']) && $_GET['q']!=$pathn){Header('Location: ?q='.$pathn);exit;}
function dosmall($src,$dst,$w,$h,$t,$max=84){
  //if(!list($w,$h,$t)=getimagesize($src))return 0;
  switch($t){
    case 1:$i=imagecreatefromgif($src);break;
    case 2:$i=imagecreatefromjpeg($src);break;
    case 3:$i=imagecreatefrompng($src);break;
    default: return 0;
  }//if($w>$max || $h>$max){//resize?
  $ratio=min($max/$w,$max/$h);
  $width=floor($ratio*$w);
  $height=floor($ratio*$h);
  //}else{$width=$w;$height=$h;}
  $ic=imagecreatetruecolor($width,$height);
  if(1==$t || 3==$t){
    imagecolortransparent($ic,imagecolorallocatealpha($ic,0,0,0,127));
    imagealphablending($ic,false);
    imagesavealpha($ic,true);
  } imagecopyresampled($ic,$i,0,0,0,0,$width,$height,$w,$h);
  switch($t){
    case 1:imagegif($ic,$dst.'.gif');break;
    case 2:imagejpeg($ic,$dst.'.jpg');break;//По умолчанию качество jpg=75
    case 3:imagepng($ic,$dst.'.png');break;
  }
  imagedestroy($ic);
  imagedestroy($i);
  return 1;
}
$c['afmv']=!(int)c('afmv');//показывать директории
$c['afmf']=(int)c('afmf');//отображение файлов - плиткой итд..
$ico=(1<$c['afmf'])?16:32;
$pages='';
function df($fd='',$ft=''){
  global $ico,$hide,$deny,$c,$patht,$pathn,$pages,$frmti,$l;
  if(''==$fd){$d=R.$patht;$fd=0;}
  else{$d=R.$fd;$fd=1;}
  if(!is_dir($d) || !$o=opendir($d))return;
  $lim=200;
  $lvl=($d==R)?0:1;
  $a=$b=[];
  $i=$j=$count=0;
  while(false!==($r=readdir($o))){
    if('.'==$r || '..'==$r || (0==$lvl && isset($hide[$r])))continue;
    if($fd && false===mb_stripos($r,$ft))continue;
    if(!is_dir($d.$r)){
      $e=ex($r);
      if(isset($deny[mb_strtolower($e)]))continue;
      $b[$r]=$e;
      ++$i;
    } elseif($c['afmv']){$a[$r]=1;++$j;}
  } closedir($o);
  if($c['afmv']){$count=$j;ksort($a,SORT_NATURAL);}
  ksort($b,SORT_NATURAL);
  $count+=$i;
  $p=isset($_GET['p'])?(int)$_GET['p']:1;
  $ps=(0!=$count%$lim)?floor($count/$lim)+1:$count/$lim;
  if(1>$p || $p>$ps)$p=1;
  $max=$p*$lim;
  $min=$max-$lim;
  $i=-1;
  $j=0;
  if($c['afmv'])//директории
    foreach($a as $k=>$v){
      ++$i;
      if($i<$min)continue;
      if($i>=$max)break;
      echo '<div role="button" onclick="st(this)" ondblclick="god(this)"',tabi(),'><span>',$k,'</span><em>',date('Y.m.d H:i',filemtime($d.$k)),'</em><ins>',$k,'</ins><p class="folder',$ico,'"></p></div>';
      ++$j;
    }
  foreach($b as $k=>$v){
    ++$i;
    if($i<$min)continue;
    if($i>=$max)break;
    if($k=='.'.$v)$k='';//имени нет
    else $k=bn($k,'.'.$v);
    $fn=$d.$k.'.'.$v;
    $fp=$k.'.'.$v;
    $size=filesize($fn);
    $bsize=bytes($size);
    $pic='<p class="'.fext($v).$ico.'"></p>';
    $a=['',''];
    $err='';
    $img='';
    $t=0;
    if('load'==$v)$err=' class="load"';
    elseif('jpg'==$v)$t=2;
    elseif('png'==$v)$t=3;
    elseif('gif'==$v)$t=1;
    if($t){
      $a=(0<$size)?getimagesize($fn):0;
      if(!$a){$err=' class="err"';$a=[$l['eropenf'].' ',''];}
      elseif($t!=$a[2]){$err=' class="erf"';$v='<b>'.$v.'</b> ['.$l['formaterr'].' '.$frmti[$a[2]].']';$a=['',''];}
      elseif($a[0]<1 || $a[1]<1){$err=' class="err"';$a=[$l['sizerr'].' '.$a[0].'x'.$a[1],''];}
      if(!$c['afmf'] && ''==$err && $a[0]<2050 && $a[1]<2050){//ограничение размера 2k..
        if($a[0]<200 && $a[1]<200){$img='<img src="'.P.$patht.$k.'.'.$v.'" alt="">';$pic='';}
        else{
          $n=TD.safename($patht,1);
          if(!is_dir($n))mkdir($n,0755,1);
          $f=safename($k);
          $x=0;
          if(is_file($n.$f.'.'.$v))$x=1;
          elseif(dosmall($fn,$n.$f,$a[0],$a[1],$a[2]))$x=1;
          if($x){$img='<img src="'.TP.$patht.$f.'.'.$v.'" alt="">';$pic='';}
        }
      }
      if(''==$err){
        if(2==$t){//1280х960=400кб  409600/1280=320 x 409600/960=427
          $ratio=min(1280/$a[0],960/$a[1]);
          $w=$size/$a[0]*$ratio;
          $h=$size/$a[1]*$ratio;
          if($w>320 && $h>427){$bsize='<b title="'.$l['notoptim'].'">'.$bsize.'</b>';}
        } $a[1]='x'.$a[1].' ';
      }
    }
    echo '<div role="button" onclick="st(this)" ondblclick="cm.dk(1)"',$err,tabi(),'>';
    if(2>$c['afmf'])echo '<span>',$k,'</span><i>',$v,' ',$a[0],$a[1],'(',$bsize,')</i><em>',date('Y.m.d H:i',filemtime($fn)),'</em><ins>',$fp,'</ins>',$img,$pic,'</div>';
    elseif(2==$c['afmf'])echo '<span>',$k,'.',$v,'</span><i>(',$bsize,')</i><em>',date('Y.m.d H:i',filemtime($fn)),'</em><q>',$a[0],$a[1],'</q><ins>',$fp,'</ins>',$pic,'</div>';
    elseif(3==$c['afmf'])echo '<span>',$k,'.',$v,'</span><i>(',$bsize,')</i><em>',date('Y.m.d H:i',filemtime($fn)),'</em><q>',$a[0],$a[1],'</q><ins>',$fp,'</ins>',$pic,'</div>';
    ++$j;
  }
  if(0==$j){
    if($fd)echo '<code role="alert"',tabi(),'>',$l['notfound'],date(' H:i:s',T),'</code>';
    $min=-1;$j++;
  }
  $pages='<span title="'.$l['showing'].'">'.($min+1).' - '.($min+$j).' ('.$count.')</span>';
  if($ps>1){
    $u=$pathn?'?q='.$pathn:'?q=0';
    if(1<$p)$pages.='<a href="'.$u.'&p='.($p-1).'" title="'.$l['goprev'].'" role="button">←</a>';
    $pages.='<a'.(1==$p?' class="on"':'').' href="'.$u.'" title="'.$l['gopage'].' 1" role="button">1</a>';
    for($z=2;$z<=$ps;$z++)$pages.='<a'.($p==$z?' class="on"':'').' href="'.$u.'&p='.$z.'" title="'.$l['gopage'].' '.$z.'" role="button">'.$z.'</a>';
    if($ps>$p)$pages.='<a href="'.$u.'&p='.($p+1).'" title="'.$l['gonext'].'" role="button">→</a>';
  }
}
if(isset($_POST['find'])){
  df(safep($_POST['find']),une($_POST['v']));
  echo '<code id="none">',$pages,'</code><input type="hidden" id="eval" value="o=ff.g(\'none\');ff.g(\'pages\').innerHTML=o.innerHTML;o.parentNode.removeChild(o)">';
  return;
}
echo '<!DOCTYPE html><html lang="',Li,'"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width,initial-scale=1.0"><title>',$l['title'],'</title><link href="fm.css" rel="stylesheet"><script async src="fm.js"></script></head><body>';
$c['afme']=(int)c('afme');
$c['afmd']=!(int)c('afmd');
$maxsize=ini_get('upload_max_filesize');
?><span class="sr-only"><?=$l['youhere'].': '.RD.'/'.$patht?></span>
<header>
  <div id="pathd"<?=($c['afme']?' class="pathsw"':'')?>>
    <div>
      <nav aria-label="Breadcrumbs"><?=$pathb?></nav>
      <input type="text" id="pathi" autocomplete="off" value="<?=RD.'/'.$patht?>">
    </div>
    <span>
      <button onclick="pathsw()" title="<?=$l['editpath']?>"></button>
      <button onclick="pathsw()" title="<?=$l['showpan']?>"></button>
    </span>
  </div>
  <div>
    <button onclick="tree(this)" title="<?=$l['showtree'].($c['afmd']?' ('.$l['enabled'].')" class="sdirs on':'" class="sdirs')?>" id="btree"></button>
    <button onclick="goimg()" title="<?=$l['gocurimdir']?>" class="goimg"></button>
    <button onclick="dirsv(this)" title="<?=$l['showdirs'].($c['afmv']?' ('.$l['enabled'].')" class="dirsv on':'" class="dirsv')?>"></button>
    <span class="fshow">
      <button onclick="df(this)" title="<?=$l['display'].' '.$l['tiles'].(0==$c['afmf']?' ('.$l['enabled'].')" class="on':'')?>"></button>
      <button onclick="df(this)" title="<?=$l['display'].' '.$l['icons'].(1==$c['afmf']?' ('.$l['enabled'].')" class="on':'')?>"></button>
      <button onclick="df(this)" title="<?=$l['display'].' '.$l['list'].(2==$c['afmf']?' ('.$l['enabled'].')" class="on':'')?>"></button>
      <button onclick="df(this)" title="<?=$l['display'].' '.$l['table'].(3==$c['afmf']?' ('.$l['enabled'].')" class="on':'')?>"></button>
    </span>
    <button onclick="rh()" title="<?=$l['refresh']?>" class="refresh"></button>
  </div>
</header>
<div id="mainc"<?=($c['afmd']?' class="tree"':'')?>><h1>Fast Site Engine File Manager</h1>
  <div id="dirs" role="tree"><?=$dirs?></div>
  <div class="right">
    <div class="flin">
      <button id="cmb" title="<?=$l['cmenu']?>"></button>
      <span><input id="findt" type="text" value="<?=$l['search']?>" autocomplete="off" onfocus="ffocus(this)" onblur="fblur(this)"><i role="tooltip"><?=$l['entersp']?></i></span>
      <button onclick="find()" title="<?=$l['find']?>"></button>
    </div>
    <?php
      echo '<div id="df" class="df',(1<$c['afmf']?$c['afmf']:''),'" role="main">';
      df();
      echo '</div><div class="pagesl"></div><div id="pages">',$pages,'</div>';
    ?>
  </div>
</div>
<footer>
  <button title="<?=$l['conf']?>" id="upcnfb" onclick="upc()"></button>
  <div class="bcb"><div><?=$l['clipb']?> (<span id="incpbd">0</span>). <?=$l['selected']?> (<span id="dfsel">0</span>).</div><div><input id="selt" type="text" value="" onfocus="this.select()" autocomplete="off"><i role="tooltip"><?=$l['fullpath']?></i></div></div>
  <button title="<?=$l['pasteleft']?>" class="bpaste" onclick="cm.dk(1,1)"></button>
  <div id="info" role="status"></div>
  <div class="dropt"><?=$l['draghere']?></div>
  <div id="dropbox"><button type="button" id="dropbut"><?=$l['selectf']?> <i>F4</i></button><input type="file" id="dropfiels" multiple></div>
</footer>
<button class="tomain" onclick="fs.to(1)"><?=$l['tomain']?></button>
<form autocomplete="off">
<input type="hidden" id="nowpath" value="<?=RP.$patht?>">
<input type="hidden" id="maxsize" value="<?=maxsize($maxsize)?>">
<input type="hidden" id="nofileapi" value="<?=$l['nofileapi']?>.">
<input type="hidden" id="eopener" value="<?=$l['reopen']?>.">
<input type="hidden" id="mkdir" value="<?=$l['entername']?>">
<input type="hidden" id="cfmdel" value="<?=$l['delsel']?>?">
<input type="hidden" id="rename" value="<?=$l['rename']?>">
<input type="hidden" id="upof" value="<?=$l['off']?>">
<input type="hidden" id="upon" value="<?=$l['enabled']?>">
<input type="hidden" id="dvon" value="<?=$l['picked']?>">
<input type="hidden" id="infc" value="<?=$l['changed']?>">
<input type="hidden" id="infs" value="<?=$l['size']?>">
<input type="hidden" id="infw" value="<?=$l['weight']?>">
</form>
<div id="out"></div>
<div id="menuh"></div>
<div id="menu" role="dialog">
<ul>
  <li><button onclick="cm.dk(1)"><?=$l['pasteonpage']?> <i>Enter</i></button></li>
  <li><button onclick="cm.dk(2)"><?=$l['pasteaslink']?> <i>Shift+Enter</i></button></li>
  <li><button onclick="cm.dk(3)"><?=$l['cut']?> <i>Ctrl+X</i></button></li>
  <li><button onclick="cm.dk(4)"><?=$l['copy']?> <i>Ctrl+C</i></button></li>
  <li><button onclick="cm.dk(5)"><?=$l['paste']?> <i>Ctrl+V</i></button></li>
  <li><button onclick="cm.dk(6)"><?=$l['selectall']?> <i>Ctrl+A</i></button></li>
  <li><button onclick="cm.dk(7)"><?=$l['delete']?> <i>Delete</i></button></li>
  <li><button onclick="cm.dk(8)"><?=$l['rename']?> <i>F2</i></button></li>
  <li><button onclick="cm.dk(9)"><?=$l['case']?> <i>Ctrl+Alt+U</i></button></li>
  <li><button onclick="cm.dk(10)"><?=$l['fix']?> <i>Shift+R</i></button></li>
  <li><button onclick="cm.dk(11)"><?=$l['createdir']?> <i>F10</i></button></li>
  <li><button onclick="cm.dk(12)"><?=$l['zip']?> <i>Shift+Z</i></button></li>
  <li><button onclick="cm.dk(13)"><?=$l['unzip']?> <i>Alt+Z</i></button></li>
  <li><button onclick="cm.dk(14)"><?=$l['download']?><i>Shift+D</i></button></li>
</ul>
</div>
<div id="upcnf" role="dialog">
  <button title="<?=($c['afmr']?$l['enabled'].'" class="upck':$l['off'])?>" onclick="upcs(this,'r')">&nbsp; <?=$l['reupload']?></button>
  <button title="<?=($c['afmn']?$l['enabled'].'" class="upck':$l['off'])?>" onclick="upcs(this,'n')">&nbsp; <?=$l['lower']?></button>
  <button title="<?=($c['afmt']?$l['enabled'].'" class="upck':$l['off'])?>" onclick="upcs(this,'t')">&nbsp; <?=$l['translate']?></button>
</div>
</body></html>