<?php
//Fast Site Engine. Copyright © AC (acwed@ya.ru), 2004-2023. All rights reserved. 2-clause BSD license.
function ismail($v){
  return preg_match('#^\S+@\S+\.\S{2,}$#',trim($v));
}
function crygen($c){
  $a='abcdefghijkmnprstuvxyzABCDEFGHIJKLMNPRSTUVXYZ23456789';//without(o=0,1=l,i=j,t=f)
  $s='';for($i=0;$i<$c;$i++)$s.=$a[mt_rand(0,52)];
  return $s;
}
function cry2long($s,$w){
  $v=unpack('V*',$s.str_repeat("\0",(4-mb_strlen($s)%4)&3));
  $v=array_values($v);
  if($w)$v[sizeof($v)]=mb_strlen($s);
  return $v;
}
function cryint($n){
  while($n>=2147483648)$n-=4294967296;
  while($n<=-2147483649)$n+=4294967296;
  return (int)$n;
}
function cryhash($s) {
  $a=['1','2','3','4','5','6','7','8','9','0','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','r','s','t','u','w','x','y','z'];
  $b=['k','zf','sm','ps','or','a3','k5','yA','t2','tO','4r','ts','Ek','Vr','sd','fGu','u','K','b','P','i','U','J','f','0','7','1','Gi','b','h','h','Y','xu','i'];
  return str_replace($a,$b,$s);
}
function crypas($s){
  if(''==$s)return '';
  $v=cry2long($s,1);
  $k=cry2long('1111111111111111',0);//key
  if(sizeof($k)<4){for($i=sizeof($k);$i<4;$i++)$k[$i]=0;}
  $n=sizeof($v)-1;
  $z=$v[$n];
  $y=$v[0];
  $delta=0x9E3779B9;
  $q=floor(6+52/($n+1));
  $sum=0;
  while(0<$q--){
    $sum=cryint($sum+$delta);
    $e=$sum>>2 & 3;
    for($p=0;$p<$n;$p++){
      $y=$v[$p+1];
      $mx=cryint((($z>>5 & 0x07ffffff)^$y<<2)+(($y>>3 & 0x1fffffff)^$z<<4))^cryint(($sum^$y)+($k[$p & 3^$e]^$z));
      $z=$v[$p]=cryint($v[$p]+$mx);
    }
    $y=$v[0];
    $mx=cryint((($z>>5 & 0x07ffffff)^$y<<2)+(($y>>3 & 0x1fffffff)^$z<<4))^cryint(($sum^$y)+($k[$p & 3^$e]^$z));
    $z=$v[$n]=cryint($v[$n] + $mx);
  } return mb_substr(cryhash(md5(join('',$v))),3,50);
}
function cryune($v,$s=1){
  $v=str_replace([0=>'`~',1=>'`^'],[0=>'&',1=>'+'],$v);
  if(isset($v[0]) && '#'==$v[0])$v=cryd($v);
  if($s)$v=strip_tags($v);
  return trim(preg_replace('#\s+#',' ',$v));
}
function POST($v,$s=1){
  return isset($_POST[$v])?cryune($_POST[$v],$s):'';
}
function aPOST($v,$s=0,$c=1){
  $v=POST($v);
  $v=false!==mb_strpos($v,'`|')?explode('`|',$v.'`|`|`|'):[0=>'',1=>$v,2=>0,3=>0];
  if($c)$v[1]=preg_replace('/[\\\'`()[]<>{}]/','',$v[1]);
  return $s?$v[1]:$v;
}
function cryd($s){
  $a=explode('#',base64_decode(mb_substr($s,1)));
  $h=cryz(base64_decode(base64_decode($a[0])));
  $s=$a[1];
  $i=(int)mb_strpos($h[1],mb_substr($s,-1));
  $j=(int)mb_strpos($h[1],mb_substr($s,0,1));
  $s=mb_substr($s,1,-1);
  $s=mb_substr($s,0,$i).mb_substr($s,$i+$j);
  return cryy(base64_decode(cryx(base64_decode($s),-1,$h[1])));
}
function crye($s,$d=0){
  if($d)return $s;
  if(''==$s)return '';
  $h=cryz();
  $s=base64_encode(cryx(base64_encode(cryy($s)),1,$h[1]));
  $l=min(mb_strlen($h[1]),mb_strlen($s))-1;
  $a=$h[1][mt_rand(1,$l)];
  $i=(int)mb_strpos($h[1],$a);
  $j=0;$z='';
  do{
    $z=$h[1][mt_rand(3,$l)];
    $j=(int)mb_strpos($h[1],$z);
  }while($i==$j || $j==0);
  return '#'.base64_encode(base64_encode(base64_encode($h[0])).'#'.$z.mb_substr($s,0,$i).crygen($j).mb_substr($s,$i).$a);
}
function cryw($s){
  $r=$c='';
  $l=mb_strlen($s);
  for($i=0;$i<$l;$i++){
    $c=$s[$i];
    if(false===mb_strpos($r,$c))$r.=$c;
  } return $r;
}
function cryx($s,$j,$k){
  $p=0;
  $r=$c='';
  $l=mb_strlen($s);
  $k='*'.cryw($k).'-';
  for($i=0;$i<$l;$i++){
    $c=$s[$i];
    $p=mb_strpos($k,$c);
    $r.=$p?$k[$p+$j]:$c;
  } return $r;
}
function cryy($s){
  $s=explode(' ',$s);
  $c=sizeof($s);
  for($i=0;$i<$c;$i++){
    $t=$s[$i];
    $l=mb_strlen($t);
    if($l>1)$t=mb_substr($t,-1).mb_substr($t,1,-1).mb_substr($t,0,1);
    $l=floor($l/2);
    if($l>2)$t=mb_substr($t,0,$l-1).mb_substr($t,$l+1,1).mb_substr($t,$l,1).mb_substr($t,$l-1,1).mb_substr($t,$l+2);
    $s[$i]=$t;
  } return implode(' ',$s);
}
function cryz($t=T){
  global $sys;
  return [$t,base64_encode(base64_encode($t.$sys['fse'].SNAME))];
}
