<?php
//Fast Site Engine. Copyright © AC (acwed@ya.ru), 2004-2023. All rights reserved. 2-clause BSD license.
class Mail{//rfc5322
  private $a='',$b=[],$d='',$f=[],$h=[],$n='',$r=0,$s='',$t=[];
  function __construct(){
    $n=md5(uniqid(rand()));//32
    $this->b[0]='FSE-1-'.mb_substr($n,0,16);
    $this->b[1]='FSE-2-'.mb_substr($n,16);
    $this->d=$this->rfc();
    $n=$this->n=str_replace('www.','',$_SERVER['SERVER_NAME']);
    $this->h['From']='noreply@'.$n;
    $this->h['Reply-To']='';
    $this->priority(3);
  }
  function attach($file,$name='',$inline=0,$type=''){
    if(is_file($file)){
      $e=$this->ex($file);
      if(''==$this->bn($name,$e))$name=$this->bn($file,$e).$e;
      if(''==$type){
        $f=finfo_open(FILEINFO_MIME_TYPE);
        $type=finfo_file($f,$file);
        finfo_close($f);
        if(!$type)$type='application/x-unknown-content-type';
      }
      $this->f[]=[0=>$file,1=>$name,2=>$inline,3=>$type];
      $this->r=1;
    } 
  }
  function at($r){
    $this->a='';
    $this->r=0;
    foreach($this->f as $k=>$a){
      if($a[2]){
        $p='inline';
        $cid='Content-ID: <'.$a[1].'>'.$r;//<img src="cid:name.jpg">
      }else{
        $p='attachment';
        $cid='';
      }
      $f=file_get_contents($a[0]);
      $this->a.='--'.$this->b[1].$r.
        'Content-type: '.$a[3].'; name="'.$a[1].'"'.$r.
        'Content-Description: '.$a[1].$r.
        'Content-Disposition: '.$p.'; filename="'.$a[1].'"'.$r.$cid.
        'Content-Transfer-Encoding: base64'.$r.$r.chunk_split(base64_encode($f));
    }
  }
  function send($mes,$t='text/html',$c='utf-8'){//text/plain
    $r="\r\n";
    if($this->r)$this->at($r);
    $b1=$this->b[0];$b2=$this->b[1];
    $e=$this->h['Reply-To'];
    if(''!=$e)$e='Reply-To: '.$e.$r;
    $h='From: '.$this->h['From'].$r.$e.'Return-Path: '.$this->h['From'].$r.
      'Date: '.$this->d.$r.'X-Priority: '.$this->h['X-Priority'].$r.'X-Mailer: Fast Site Engine'.$r.
      'MIME-Version: 1.0'.$r.'Content-Type: ';
    $q='Content-Type: '.$t.'; charset='.$c.$r.'Content-Transfer-Encoding: 8bit'.$r.$r.$mes.$r.$r;
    if(''==$b2){
      $h.='multipart/alternative; boundary="'.$b1.'"'.$r;
      $m='--'.$b1.$r.$q;
    }else{
      $h.='multipart/alternative; boundary="'.$b1.'"'.$r;
      $m='--'.$b1.$r.'Content-Type: multipart/related; boundary="'.$b2.'"'.$r.$r.'--'.$b2.$r.$q;
    }
    mail(implode(', ',$this->t),'=?'.$c.'?Q?'.str_replace('+','_',str_replace('%','=',urlencode($this->s))).'?=',
      wordwrap($m,76,$r).$this->a.(''==$b2?'':'--'.$b2.'--'.$r).$r.'--'.$b1.'--'.$r,$h);
  }
  function from($v){
    $v=trim((string)$v);
    if(''!=$v)$this->h['From']=$v;
  }
  function priority($v){
    $a=[1=>'1 (Highest)',2=>'2 (High)',3=>'3 (Normal)',4=>'4 (Low)',5=>'5 (Lowest)'];
    $this->h['X-Priority']=$a[$v];
  }
  function replyto($v){
    $this->h['Reply-To']=trim($v);
  }
  function subject($v){
    $this->s=$v;
  }
  function to($v,$add=0){
    if(!$add)$this->t=[];
    $this->t[]=trim($v);
  }
  function a(){
    $a=func_get_args();
    foreach($a as $k=>$v){
      if(''!=$v)return explode(';',$v);
    } return [];
  }
  function bn($s,$e=''){
    $s=preg_replace('#/+$#','',$s);
    $a=explode('/',$s);$s=end($a);//basename($s,$e)-->имя-1.xxx=-1.xxx
    if(''!=$e)$s=mb_substr($s,0,-mb_strlen($e));
    return $s;
  }
  function ex($s){
    return mb_substr(strrchr($s,'.'),1);
  }
  function is($v){
    return preg_match('#^\S+@\S+\.\S{2,}$#',trim($v));
  }
  function rfc(){
    $t=$_SERVER['REQUEST_TIME'];
    $d=date('Z',$t);
    $s=$d<0?'-':'+';
    $d=abs($d);
    $d=$d/3600*100+$d%3600/60;
    return sprintf('%s %s%04d',date('D, j M Y H:i:s',$t),$s,$d);
  }
  function safename($s,$d=0){
    if(!$d)$s=str_replace('/','',$s);
    $s=trim($s);
    return str_replace(['*','"','\\',':','<','>','|','?','!','@','#','$','&','~','%','(',')','[',']','{','}','\'',';','`','='],'',$s);
  }
  function valid(){
    $a=func_get_args();
    foreach($a as $k=>$v){
      $o=$v;if(false!==mb_strpos($o,'<')){$o=explode('<',$o);$o=explode('>',$o[1]);$o=$o[0];}//"name" <email>
      if(false!==mb_strpos($o,$this->n) && $this->is($o))return $v;
    }
  }
}