<?php
//Fast Site Engine. Copyright © AC (acwed@ya.ru), 2004-2023. All rights reserved. 2-clause BSD license.
if(!function_exists('sc')){
function c($n){
  return isset($_COOKIE[$n])?htmlspecialchars($_COOKIE[$n],ENT_QUOTES):false; //<>, ", ', /\, ;
}
function sc($n,$s='',$t=-1,$o=0){
  if(''!=$s && -1==$t)$t=2592000;
  setcookie($n,$s,['expires'=>T+$t,'path'=>'/','domain'=>SNAME,'secure'=>1,'httponly' =>$o,'samesite'=>'lax']);
}
}
function se($v){
  return serialize($v);
}
function nse($v){
  $v=unserialize($v);
  if(!is_array($v)) $v=[];
  return $v;
}
function nf($v){
  return number_format((int)$v,0,'.',' ');
}
function unecr($v){
  $a=[0=>'`~',1=>'`^'];
  $r=[0=>'&',1=>'+'];
  return str_replace($a,$r,stripslashes($v));
}
function InPOST($v){
  return isset($_POST[$v])?trim(unecr($_POST[$v])):'';
}
function sid(){
  srand((double)microtime() * 1000000);
  return md5(uniqid(rand(),1));//strlen(32)
}
//if(!defined('IP'))define('IP',$_SERVER['REMOTE_ADDR']);
define('BN','_db');
$db=[];
$dbl=['_db'=>['on'=>false,'h'=>'localhost','pt'=>3306,'u'=>'','p'=>'']];
//----------------------------------------------------------------------
function _close(){
  global $db,$dbl;
  foreach($dbl as $k=>$v){
   if($v['on'])$db[$k]->close();
 }
}
function _go($v='./'){
  _close();
  Header('Location: '.$v);
  exit;
}
function _exit($s=' '){
  _close();
  exit($s);
}
$dbe=[0=>[0=>'\\',1=>"'",2=>'"',3=>"\x00",4=>"\x1a",5=>"\r",6=>"\n"],1=>[0=>'\\\\',1=>"\'",2=>'\"',3=>"\\x00",4=>"\\x1a",5=>"\\r",6=>"\\n"]];
function e($v){
  global $dbe;
  return is_numeric($v)?$v:'\''.str_replace($dbe[0],$dbe[1],$v).'\'';
}
function dbConnect($name=BN){
  global $db,$dbl;
  if($dbl[$name]['on'])return;
  $db[$name]=new mysqli($dbl[$name]['h'],$dbl[$name]['u'],$dbl[$name]['p'],$name,$dbl[$name]['pt']);
  if(0==mysqli_connect_errno())$dbl[$name]['on']=true;
  else _exit('Can\'t dbConnect to: '.$name);//err: mysqli_connect_error() //$dbl[$name]['on']=('resource' === gettype($db[$name]));
  dbq('SET NAMES utf8');
}
function dbClose($name=BN){
  global $db,$dbl;
  if(!$dbl[$name]['on'])return;
  $dbl[$name]['on']=$db[$name]->close();
}
function dberr($e){
  $e='error: '.$e;
  //$f=fopen('sql_errors.txt','a'); fwrite($f, $e.N); fclose($f);
  _exit($e);
}
function dbq($q){
  global $db;
  dbConnect(BN);
  return $db[BN]->query($q)||dberr('dbq('.$db[BN]->error.$q);
}
function dbqr($q){
  global $db;
  dbConnect(BN);
  $r=$db[BN]->query($q);
  return(!$r||0==$r->num_rows)?false:$r;
}
function dbqf($q){
  global $db;
  dbConnect(BN);
  $r=$db[BN]->query($q);
  return(!$r||0==$r->num_rows)?false:$r->fetch_row();
}
function dbqa($q){
  global $db;
  dbConnect(BN);
  $r=$db[BN]->query($q);
  return(!$r||0==$r->num_rows)?false:$r->fetch_assoc();
}
